// a quicky dungen game

#include "dg4p.h"

char dungeonname[30];
int gamespeed, doors[11][21], floor[4][10][10], depth, c[4], rdu[4], players;
int doorx[4], doory[4], startx, starty, mysticx, mysticy, rooms[4][2];
int dcopy[11][21];
char walls[4][10], gwall[4][4][10][2];
char bits[8] = {128, 64, 32, 16, 8, 4, 2, 1};
char controls[10][9] = {{"Human 1 "},{"Human 2 "},{"Human 3 "},{"Human 4 "},
                       {"Stand   "},{"Task    "},
                       {"Follow 1"},{"Follow 2"},{"Follow 3"},{"Follow 4"}};
char classes[12][12] = {{"Warrior"}, {"Peasant"}, {"Wizard"}, {"Thief"},
                       {"Sage"}, {"Minstrel"}, {"Giant"}, {"Gnome"},
                       {"Elf"}, {"Hero"}, {"Legend"}, {"God"}};
int classatt[12][12] = {{20, 300, 80, 50, 120, 150, 150, 150, 80, 400, 30, 0}, //1500
                       {100, 100, 100, 100, 100, 200, 100, 100, 100, 500, 15, 15},//1500
                       {300, 20, 100, 100, 70, 200, 70, 70, 80, 500, 10, 20},//1500
                       {140, 140, 130, 140, 50, 100, 20, 80, 200, 500, 15, 15},//1500
                       {150, 100, 150, 150, 100, 100, 150, 80, 20, 500, 15, 15},//1500
                       {140, 140, 130, 140, 80, 100, 150, 20, 100, 500, 15, 15},//1500
                       {100, 190, 50, 100, 140, 140, 140, 140, 100, 400, 30, 0},//1500
                       {50, 50, 50, 50, 50, 100, 50, 50, 50, 1000, 15, 15},//1500
                       {150, 150, 150, 150, 150, 150, 150, 150, 150, 150, 15, 15},//1500
                       {2, 2, 2, 2, 2, 2, 2, 2, 2, 2, 0, 0},
                       {4, 4, 4, 4, 4, 4, 4, 4, 4, 4, 0, 0},
                       {0, 0, 0, 0, 0, 0, 0, 0, 0, 10, 0, 0}};
sndsys snd;
int sb[10];
int ssilence[10] = {0,0,0,0,0,0,0,0,0,0,};
int sblank[10] = {-1,-1,-1,-1,-1,-1,-1,-1,-1,-1};
int scurse[10] = {1000, 1100, 1200, 1300, 1400, 1500, 1600, 1700, 1800, 1900};
int scure[10] = {1900, 1800, 1700, 1600, 1500, 1400, 1300, 1200, 1100, 1000};
int sswish[10] = {2000, 250, 300, -1, -1, -1, -1, -1, -1, -1};
int sfind[10] = {1000, 500, 333, 1000, 500, 333, 1000, 500, 333, -1};
int smagic[10] = {-500, -495, -490, -485, -480, -1, -1, -1, -1, -1};
int smonhit[10] = {-300, -200, -100, -1, -1, -1, -1, -1, -1, -1};
int splayhit[10] = {-5000, -2000, -3000, -1, -1, -1, -1, -1, -1, -1};
int sheal[10] = {-100, -200, -100, -1, -1, -1, -1, -1, -1, -1};
int swind[10] = {-1000, -1010, -1020, -1030, -1040, -1050, -1060, -1070, -1080, -1090};
int sboom[10] = {-100, -90, -70, -60, -50, -1, -1, -1, -1, -1};
int sbolt[10] = {-100, -101, -102, -103, -104, -105, -106, -107, -108, -109};
int slight[10] = {-100, -110, -100, -110, -1, -1, -1, -1, -1, -1};
int sdead[10] = {150, 100, 140, 90, 130, 80, 120, 70, 110, 60};
int sdrop[10] = {3000, 0, 0, 3000, 0, 3000, 3000, 3000, 3000, 3000};

char gmap[16] = {32, 25, 27, 192, 24, 179, 218, 195, 26, 217, 196, 193, 191, 180, 194, 197};
char themap[10][10], password[41] = {""};
int quicksaved = 0, characters, cheat = 0;

extern item itemlist[60];
extern player character[8];
extern ingameplay pc[4];
extern monster monsters[6];
extern ingamemon mon[4][10];
extern room map[10][10];
extern projectile shots[36];
extern keys playkeys[4];

void addplayer(void)
{
  char labels[12][13] = {{"    Strength"}, {"       Magic"}, {"     Stamina"},
                       {"       Guard"}, {"Intelligence"}, {"        Luck"},
                       {"   Dexterity"}, {"    Charisma"}, {"    Morality"},
                       {"    Level Up"}, {"         HPs"}, {"         MPs"}};
  int b, d, cx = 0, ox = 1;
  if (characters >= 8)
  {
    cputs("Too many characters.\r\n");
    return;
  }
  for (int a = 0;a < 8;a++)
  {
    if (character[a].dead == 0)
      break;
  }
  clrscr();
  cprintf("you are character number %d, remember this number.\r\n", a);
  cputs("your name is? ....................");
  gotoxy(15,2);
  getstr(&character[a].playername, 20);
  character[a].sex = 100;
  do {
  cputs("\r\nyou are a (m)ale/(f)emale?\r\n");
  switch(getch())
  {
    case (int)'m': character[a].sex = MALE; break;
    case (int)'f': character[a].sex = FEMALE; break;
    default: cputs("I don't think there is such a sex...\r\n");
  }
  } while (character[a].sex == 100);
  clrscr();
  gotoxy(1, 1);
  cputs("Choose your class, or character advancment cost (you begin 2000 exp.).");
  for (b = 0;b < 9;b++)
  {
    gotoxy(3, b+16);
    cputs(classes[b]);
  }
  for (b = 0;b < 12;b++)
  {
    for (d = 0;d < 13;d++)
    {
      if (b < 10)
        gotoxy((5+(b*4))+d, 3+d);
      else
        gotoxy((7+(b*4))+d, 3+d);
      putch(labels[b][d]);
    }
  }
  gotoxy(58, 13);
  putch(',');
  gotoxy(62, 13);
  putch(',');
  gotoxy(15, 15);
  for (b = 0;b < 60;b++)
    putch('-');
  for (b = 0;b < 9;b++)
  {
    for (d = 0;d < 12;d++)
    {
      if (d < 10)
        gotoxy(17+(d*4), 16+b);
      else
        gotoxy(19+(d*4), 16+b);
      cprintf("%d", classatt[b][d]);
    }
  }
  b = 0;
  do {
    if (cx < 0)
      cx = 8;
    else if (cx > 8)
      cx = 0;
    if (cx != ox)
    {
      gotoxy(1, ox+16);
      putch(32);
      gotoxy(1, cx+16);
      putch('>');
      ox = cx;
    }
    switch(getkey())
    {
      case UP: cx--; break;
      case DOWN: cx++; break;
      case SPACE: b = 1; break;
    }
  } while (b == 0);
  character[a].dead = 1;
  character[a].level = cx;
  character[a].strength = 0;
  character[a].magic = 0;
  character[a].stamina = 0;
  character[a].guard = 0;
  character[a].intelligence = 0;
  character[a].luck = 0;
  character[a].dexterity = 0;
  character[a].charisma = 0;
  character[a].morality = 0;
  character[a].experience = 2000;
  character[a].money = 0;
  character[a].hpcap = classatt[cx][10];
  character[a].mpcap = classatt[cx][11];
  character[a].items = 6;
  character[a].cursed = NONE;
  character[a].weight = 0;
  character[a].oillight = 0;
  character[a].torchlight = 200;
  character[a].playing = 0;
  for (b = 0;b < 3;b++)
    character[a].arrows[b] = 10;
  for (b = 0;b < 60;b++)
  {
    character[a].number[b] = 0;
    character[a].inventory[b] = 100;
  }
  for (b = 0;b < 6;b++)
  {
    character[a].inventory[b] = b;
    character[a].number[b] = 1;
  }
  gotoxy(1, 25);
  modplayer(a);
}

void modplayer(int a)
{
  int cx = 12, ox = 13, b, d, e;
  for (b = 0;b < 8;b++)
    if (character[b].dead == 1)
      characters++;
  if (characters <= 0)
  {
    cputs("No characters.\r\n");
    return;
  }
  if (a == -1)
  {
    do {
      cputs("enter your character number ");
      a = getche();
      a -= 48;
      if (a == 9)
        return;
    } while (a > 7 || a < 0);
    if (character[a].dead == 0)
    {
      cprintf("\r\ncharacter %d is dead!", a);
      return;
    }
    cprintf("\r\nhello, %s.", character[a].playername);
    getch();
  }
  clrscr();
  cputs("stength: ability to harm enemy and knock down doors\r\n");
  cputs("magic: what spells can be cast, and how strong they are\r\n");
  cputs("stamina: how fast you can move carring a given amount of weight\r\n");
  cputs("guard: ability to avoid enemy attacks\r\n");
  cputs("perception: ability to find hidden doors and traps\r\n");
  cputs("luck: has positive effect on a number of things\r\n");
  cputs("dexterity: ability to open locks without keys\r\n");
  cputs("charisma: you can talk monsters into leaving you alone, or scare them away\r\n");
  cputs("morality: some items can only be used by the pure of heart\r\n");
  for (;;)
  {
    if (cx < 12)
      cx = 22;
    else if (cx > 22)
      cx = 12;
    if (cx != ox)
    {
      gotoxy(28, ox);
      putch(32);
      gotoxy(28, cx);
      putch('<');
      ox = cx;
    gotoxy(1,10);
    cprintf("experience: %d   \r\n", character[a].experience);
    cprintf("ability      cost   you have\r\n");
    cprintf("strength            %d\r\n", character[a].strength);
    cprintf("magic               %d\r\n", character[a].magic);
    cprintf("stamina             %d\r\n", character[a].stamina);
    cprintf("guard               %d\r\n", character[a].guard);
    cprintf("perception          %d\r\n", character[a].intelligence);
    cprintf("luck                %d\r\n", character[a].luck);
    cprintf("dexterity           %d\r\n", character[a].dexterity);
    cprintf("charisma            %d\r\n", character[a].charisma);
    cprintf("morality            %d\r\n", character[a].morality);
    cprintf("level               X\r\n");
    cprintf("done         X      X\r\n");
    for (b = 0;b < 10;b++)
    {
      gotoxy(14, 12+b);
      if (character[a].level < 10)
        printf("%d  ", classatt[character[a].level][b]);
      else
        printf("%d  ", classatt[character[a].level%10][b] * classatt[8+character[a].level/10][b]);
    }
  for (int b = 0;b < 3;b++)
  {
    switch (b)
    {
      case 0: d = 100; break;
      case 1: d = 60; break;
      case 2: d = 30; break;
    }
    e = 0;
    e += character[a].strength;
    e += character[a].magic;
    e += character[a].stamina;
    e += character[a].guard;
    e += character[a].intelligence;
    e += character[a].luck;
    e += character[a].dexterity;
    e += character[a].charisma;
    e += character[a].morality;
    if (e >= d*9)
    {
      switch (b)
      {
        case 0: character[a].level = character[a].level%10 + 30; break;
        case 1: character[a].level = character[a].level%10 + 20; break;
        case 2: character[a].level = character[a].level%10 + 10; break;
      }
      gotoxy(1, 25);
      cprintf("Congratulations!  You have become a %s.    ", classes[8+character[a].level/10]);
      break;
    }
  }
    if (character[a].strength > 100)
      character[a].strength = 100;
    if (character[a].magic > 100)
      character[a].magic = 100;
    if (character[a].stamina > 100)
      character[a].stamina = 100;
    if (character[a].guard > 100)
      character[a].guard = 100;
    if (character[a].intelligence > 100)
      character[a].intelligence = 100;
    if (character[a].luck > 100)
      character[a].luck = 100;
    if (character[a].dexterity > 100)
      character[a].dexterity = 100;
    if (character[a].charisma > 100)
      character[a].charisma = 100;
    if (character[a].morality > 100)
      character[a].morality = 100;
    if (character[a].hpcap > 30000)
      character[a].hpcap = 30000;
    if (character[a].mpcap > 30000)
      character[a].mpcap = 30000;
    }
    switch(getkey())
    {
      case UP: cx--; break;
      case DOWN: cx++; break;
      case (int)'F': if (cheat == 1)
                       character[a].experience = 30000;
                     break;
      case SPACE: if (character[a].level < 10)
                    e = classatt[character[a].level][cx-12];
                  else
                    e = classatt[character[a].level%10][cx-12] * classatt[8+character[a].level/10][cx-12];
                  if (character[a].experience >= e && cx < 22)
		  {
		    switch(cx)
		    {
		      case 12: character[a].strength++; break;
		      case 13: character[a].magic++; break;
		      case 14: character[a].stamina++; break;
		      case 15: character[a].guard++; break;
		      case 16: character[a].intelligence++; break;
		      case 18: character[a].dexterity++; break;
                      case 17: character[a].luck++; break;
		      case 19: character[a].charisma++; break;
		      case 20: character[a].morality++; break;
                      case 21: character[a].hpcap += (character[a].stamina + character[a].guard)+random(character[a].luck);
		               character[a].mpcap += (character[a].magic*2)+random(character[a].luck);
                               break;
		    }
		    if (character[a].level < 10)
                      character[a].experience -= classatt[character[a].level][cx-12];
                    else
                      character[a].experience -= classatt[character[a].level%10][cx-12]*classatt[8+character[a].level/10][cx-12];
                    ox = 22;
		  }
		  else if (cx == 22)
		  {
		    clrscr();
                    return;
		  }
    }
  }

}

void viewplayer(int a)
{
  char sexstr[7];
  if (characters <= 0)
  {
    cputs("No characters.\r\n");
    return;
  }
  if (a == -1)
  {
    do {
      cputs("enter your character number ");
      a = getche();
      a -= 48;
      if (a == 9)
        return;
    } while (a > 7 || a < 0);
    if (character[a].dead == 0)
    {
      cprintf("\r\ncharacter %d is dead!\r\n", a);
      return;
    }
  }
  clrscr();
  cprintf("player # %d   name: %s.\r\n", a, character[a].playername);
  if (character[a].sex == MALE)
    strcpy(sexstr, "Male");
  else
    strcpy(sexstr, "Female");
  cprintf("$%d   max hp: %d   max mp: %d   sex: %s\r\n", character[a].money, character[a].hpcap, character[a].mpcap, sexstr);
  cprintf("class: ");
  if (character[a].level >= 10)
    cprintf("%s-", classes[8+character[a].level/10]);
  cprintf("%s   experience: %d  weight: %d\r\n", classes[character[a].level%10], character[a].experience, character[a].weight);
  cprintf("strength:     %d\r\n", character[a].strength);
  cprintf("magic:        %d\r\n", character[a].magic);
  cprintf("stamina:      %d\r\n", character[a].stamina);
  cprintf("guard:        %d\r\n", character[a].guard);
  cprintf("perception    %d\r\n", character[a].intelligence);
  cprintf("luck:         %d\r\n", character[a].luck);
  cprintf("dexterity:    %d\r\n", character[a].dexterity);
  cprintf("charisma:     %d\r\n", character[a].charisma);
  cprintf("morality:     %d\r\n", character[a].morality);
  if (character[a].cursed != NONE)
    cputs("you have been cursed!\r\n");
  cputs("tip: to view inventory, choose sell items and sell nothing.\r\n");
  getch();
  clrscr();
}

void buyitems(void)
{
  int ifs = 0, a = 0;
  char sexstr[7];
  int sel[20];
  if (characters <= 0)
  {
    cputs("No characters.\r\n");
    return;
  }
  do {
    cputs("enter your character number ");
    a = getche();
    a -= 48;
    if (a == 9)
      return;
  } while (a > 7 || a < 0);
  if (character[a].dead == 0)
  {
    cprintf("\r\ncharacter %d is dead!", a);
    return;
  }
  cprintf("\r\nhello, %s.", character[a].playername);
  cputs("\r\nA large, jolly man greats you at the door to the armory,\r\n");
  cputs("and bids you good day.\r\n");
  getch();
  clrscr();
  for (int b = 0;b < 60;b++)
  {
    if (itemlist[b].iclass == WEAPON && (itemlist[b].instock == 1 || itemlist[b].instock == 3))
      sel[ifs++] = b;
  }
  purchase(sel, ifs, a);
  ifs = 0;
  for (b = 0;b < 60;b++)
  {
    if (itemlist[b].iclass == ARMOR && (itemlist[b].instock == 1 || itemlist[b].instock == 3))
      sel[ifs++] = b;
  }
  purchase(sel, ifs, a);
  ifs = 0;
  clrscr();
  cputs("\r\nThe tall, thin clerk of the general store looks up from his books and\r\n");
  cputs("stares at you through his thin rimmed glasses.  \"Another one, eh?\"\r\n");
  getch();
  for (b = 0;b < 60;b++)
  {
    if (itemlist[b].iclass == EQUIPMENT && (itemlist[b].instock == 1 || itemlist[b].instock == 3))
      sel[ifs++] = b;
  }
  sel[ifs++] = 55;
  purchase(sel, ifs, a);
  ifs = 0;
  clrscr();
  if (character[a].sex == MALE)
    strcpy(sexstr, "man");
  else
    strcpy(sexstr, "lady");

  cputs("\r\nWhen you enter the magic shop, it is empty.  Then a haggard old woman come\r\n");
  cprintf("out of the back and says:  \"");
  if (character[a].cursed == NONE)
    cprintf("And how may I help you young %s.\"\r\n", sexstr);
  else
  {
    cprintf("I sense a dark pressence has entered.\"\r\n\"I can cure you here for $10.\"\r\ny/n");
    switch (getch())
    {
      case (int)'y': character[a].cursed = NONE;
		     if (character[a].money >= 10)
		       character[a].money -= 10;
		     else
		       character[a].money = 0;
                     cputs("\r\nAbracadabra!  You have been cured.\r\n");
		     break;
      default: cputs("\r\nIf that's what you want.\r\n"); break;
    }
  }
  getch();
  for (b = 0;b < 60;b++)
  {
    if (itemlist[b].iclass == SPELL && (itemlist[b].instock == 1 || itemlist[b].instock == 3))
      sel[ifs++] = b;
  }
  purchase(sel, ifs, a);
  clrscr();
}

void purchase(int selection[20], int itemsforsale, int a)
{
  int cx = 2, ox = 3, c, leavehere = 0, b;
  char ss[7];
  if (character[a].sex == MALE)
    strcpy(ss, "Sir");
  else
    strcpy(ss, "Ma'am");
  clrscr();
  do
  {
    gotoxy(1,1);
    cprintf("item                 cost  weight  rating  level  MP's");
    for (b = 0;b < itemsforsale;b++)
    {
      gotoxy(3, b+2);
      cprintf("%s   %d  ", itemlist[selection[b]].itemname, itemlist[selection[b]].cost);
      gotoxy(29, b+2);
      cprintf("%d  ", itemlist[selection[b]].weight);
      gotoxy(37, b+2);
      cprintf("%d  ", itemlist[selection[b]].level);
      gotoxy(45, b+2);
      cprintf("%d  ", itemlist[selection[b]].reqattr);
      gotoxy(52, b+2);
      cprintf("%d  ", itemlist[selection[b]].magic);
    }
    gotoxy(1, 21);
    cprintf("$%d  weight %d/%d  press SPACE to buy and ESC to end. ", character[a].money, character[a].weight, character[a].stamina*10);
    if (cx < 2)
      cx = itemsforsale+1;
    else if (cx > itemsforsale+1)
      cx = 2;
    if (cx != ox)
    {
      gotoxy(1, ox);
      putch(32);
      gotoxy(1, cx);
      putch('>');
      ox = cx;
    }
    switch(getkey())
    {
      case UP: cx--; break;
      case DOWN: cx++; break;
      case SPACE: if (itemlist[selection[cx-2]].cost <= character[a].money)
		  {
                    if (itemlist[selection[cx-2]].special != 20 || (itemlist[selection[cx-2]].special == 20 && character[a].morality >= itemlist[selection[cx-2]].reqattr))
                    {
                      if (selection[cx-1] == 1)
                        character[a].inventory[1] = 1;
		      if (additem(a, selection[cx-2]) != 0)
			character[a].money -= itemlist[selection[cx-2]].cost;
		      else
		      {
			gotoxy(1, 23);
			cprintf("I'm sorry, but you don't have enough space, %s.\r\n", ss);
		      }
                    }
                    else if (itemlist[selection[cx-2]].iclass == WEAPON)
                    {
                      gotoxy(1, 23);
                      cprintf("You are unable to pick up the blade.            \r\n");
                    }
                    else
                    {
                      gotoxy(1, 23);
                      cprintf("The cloth does not budge from the counter.      \r\n");
                    }
		  }
		  else
		  {
		    gotoxy(1, 23);
		    cprintf("I'm afraid you don't have enough money, %s.\r\n", ss);
		  }
		  break;
      case ESCAPE: leavehere = 1; break;
    }
  } while (leavehere == 0);
}

void sellitems(void)
{
  int cx = 2, ox = 3, a = 0, leavehere = 0, b, d = 0;
  char ss[7];
  if (characters <= 0)
  {
    cputs("No characters.\r\n");
    return;
  }
  do {
    cputs("enter your character number ");
    a = getche();
    a -= 48;
    if (a == 9)
      return;
  } while (a > 7 || a < 0);
  if (character[a].dead == 0)
  {
    cprintf("\r\ncharacter %d is dead!\r\n", a);
    return;
  }
  cprintf("\r\nHello %s.\r\n", character[a].playername);
  getch();
  clrscr();
  if (character[a].sex == MALE)
    strcpy(ss, "Sir");
  else
    strcpy(ss, "Ma'am");
  clrscr();
  do
  {
    gotoxy(1,1);
    cprintf("item                 value weight  rating  level  MP's  you have");
    for (b = 6+d;b < 29+d;b++)
    {
      if (character[a].inventory[b] == 100)
      {
	gotoxy(2, b-4-d);
	cprintf("                                                              ");
      }
      else
      {
      gotoxy(3, b-4-d);
      cprintf("%s   %d   ", itemlist[character[a].inventory[b]].itemname, itemlist[character[a].inventory[b]].cost/10);
      gotoxy(29, b-4-d);
      cprintf("%d   ", itemlist[character[a].inventory[b]].weight);
      gotoxy(37, b-4-d);
      cprintf("%d   ", itemlist[character[a].inventory[b]].level);
      gotoxy(45, b-4-d);
      cprintf("%d   ", itemlist[character[a].inventory[b]].reqattr);
      gotoxy(52, b-4-d);
      cprintf("%d   ", itemlist[character[a].inventory[b]].magic);
      gotoxy(58, b-4-d);
      cprintf("%d   ", character[a].number[b]);
      }
    }
    if (character[a].items > 6)
    {
        gotoxy(1, 25);
        cprintf("$%d  weight %d/%d  press SPACE to sell one item and ESC to end.  ", character[a].money, character[a].weight, character[a].stamina*10);
      if (cx < 2)
      {
        cx = 2;
        if (--d < 0)
        {
	  cx = 24;
          d = 31;
        }
      }
      else if (cx > 24)
      {
        cx = 24;
        if (++d > 31)
        {
          d = 0;
       	  cx = 2;
        }
      }
      if (cx != ox)
      {
	gotoxy(1, ox);
	putch(32);
	gotoxy(1, cx);
	putch('>');
	ox = cx;
      }
      switch(getkey())
      {
	case UP: cx--; break;
	case DOWN: cx++; break;
	case SPACE: if (character[a].inventory[cx+4+d] != 100)
                    {
                      character[a].money += itemlist[character[a].inventory[cx+4+d]].cost/10;
                      if (character[a].money > 30000)
                        character[a].money = 30000;
                      removeitem(a, cx+4+d);
                    }
		    break;
        case (int)'C': if (cheat == 1)
                         additem(a, cx+4+d);
                       break;
	case ESCAPE: leavehere = 1; break;
      }
    }
    else
      leavehere = 1;
  } while (leavehere == 0);
  clrscr();
}

int additem(int p, int i)
{
  int nothere = 0;
  for (int a = 0;a < 60;a++)
  {
    if (character[p].inventory[a] == i && character[p].number[a] < 1000)
    {
      character[p].number[a]++;
      nothere = i;
      character[p].weight += itemlist[character[p].inventory[a]].weight;
    }
  }
  if (character[p].items < 60 && nothere == 0)
  {
    character[p].inventory[character[p].items] = i;
    character[p].number[character[p].items] = 1;
    character[p].weight += itemlist[character[p].inventory[character[p].items]].weight;
    nothere = i;
    character[p].items++;
  }
  return nothere;
}

int removeitem(int p, int i)
{
  int itemsleft = character[p].number[i] - 1;
  character[p].number[i]--;
  character[p].weight -= itemlist[character[p].inventory[i]].weight;
  if (character[p].inventory[i] >= 14 && character[p].inventory[i] <= 16)
    character[p].arrows[character[p].inventory[i]-14] = 10;
  if (character[p].number[i] <= 0)
  {
    character[p].items--;
    for (int b = i;b < character[p].items;b++)
    {
      character[p].inventory[b] = character[p].inventory[b+1];
      character[p].number[b] = character[p].number[b+1];
    }
    character[p].inventory[character[p].items] = 100;
    character[p].number[character[p].items] = 0;
  }
  return itemsleft;
}

void shift(int ch, int i)
{
  if (i == pc[ch].rhand)
    pc[ch].rhand = 0;
  if (i == pc[ch].lhand)
    pc[ch].lhand = 0;
  if (i == pc[ch].wearing)
    pc[ch].wearing = 0;
  if (i == pc[ch].ring)
    pc[ch].ring = 0;
  if (i < pc[ch].rhand)
    pc[ch].rhand--;
  if (i < pc[ch].lhand)
    pc[ch].lhand--;
  if (i < pc[ch].wearing)
    pc[ch].wearing--;
  if (i < pc[ch].ring)
    pc[ch].ring--;
}

void createdungeon(void)
{
  int rx, ry, b, rdx, rdy;
  createmonsters();
  char prefix[4][10] = {{"Dark "}, {"Damp "}, {"Evil "}, {"Stinking "}};
  char word[4][10] = {{"Hole "}, {"Dungeon "}, {"Lair "}, {"Caverns "}};
  char postfix[4][12] = {{"Dispair"}, {"Doom"}, {"Death"}, {"No Return"}};

  strcpy(dungeonname, "The ");
  switch (random(5))
  {
    case 0: strcat(dungeonname, word[random(4)]); break;
    case 1:
    case 2: strcat(dungeonname, prefix[random(4)]);
	    strcat(dungeonname, word[random(4)]); break;
    case 3:
    case 4: strcat(dungeonname, word[random(4)]);
	    strcat(dungeonname, "of ");
	    strcat(dungeonname, postfix[random(4)]); break;
  }
  for (int a = 0;a < 10;a++)
  {
    for (b = 0;b < 10;b++)
    {
      map[a][b].monsters = random(10);
      map[a][b].traps = random(random(depth));
      map[a][b].chests = random(3);
      map[a][b].goodies = 0;
      if (random(5) == 0)
        map[a][b].flooded = 1;
      else
        map[a][b].flooded = 0;
      map[a][b].walls = random(30);
      map[a][b].fire = 0;
      if (random(depth) == 0)
	map[a][b].torch = UNLIT;
      else
	map[a][b].torch = NOTORCH;
      map[a][b].monstertype = &monsters[(map[a][b].mtindex = random(5))];
    }
  }
  startx = (rx = random(10));
  starty = (ry = random(10));
  mysticx = random(10);
  mysticy = random(10);
  for (a = 0;a < 11;a++)
  {
    for (b = 0;b < 21;b++)
      doors[a][b] = SOLID;
  }
  for (a = 0;a < depth*10;a++)
  {
    rdx = 0;
    rdy = 0;
    b = random(4);
    switch(b+1)
    {
      case MUP: if (ry == 0)
                {
                  rdy = 1;
                  b = MDOWN-1;
                }
                else
                  rdy = -1;
                break;
      case MDOWN: if (ry == 9)
                {
                  rdy = -1;
                  b = MUP-1;
                }
                else
                  rdy = 1;
                break;
      case MRIGHT: if (rx == 9)
                {
                  rdx = -1;
                  b = MLEFT-1;
                }
                else
                  rdx = 1;
                break;
      case MLEFT: if (rx == 0)
                {
                  rdx = 1;
                  b = MRIGHT-1;
                }
                else
                  rdx = -1;
                break;
    }
    doors[rx+doorx[b]][(ry * 2) + doory[b]] = (random(5) * 10) + (random(7) + 2);
    rx += rdx;
    ry += rdy;
  }
  map[startx][starty].monsters = 0;
  map[startx][starty].traps = 0;
  map[startx][starty].chests = 0;
  map[startx][starty].goodies = 0;
  map[startx][starty].torch = LIT;
  map[startx][starty].flooded = 0;
  map[startx][starty].walls = 0;
  map[startx][starty].fire = 0;
  for (a = 0;a < 11;a++)
  {
    for (b = 0;b < 21;b++)
      dcopy[a][b] = doors[a][b];
  }
}

void createmonsters(void)
{
  int b, e, d;
  char prefix[7][11] = {{""}, {"Giant "}, {"Were"}, {"Undead "}, {"Young "}, {"Skeletal "}, {"Dark "}};
  char mname[18][8] = {{"Rat"}, {"Bat"}, {"Earwig"}, {"Knight"}, {"Roach"},
		 {"Tiger"}, {"Panther"}, {"Wolf"}, {"Slime"}, {"Troll"},
		 {"Spider"}, {"Wizard"}, {"Worm"}, {"Serpent"}, {"Vulture"},
		 {"Spark"}, {"Orc"}, {"Orge"}};
  int used[5] = {100, 100, 100, 100, 100};
  for (int a = 0;a < 5;a++)
  {
    if (depth < 10)
      monsters[a].hpcap = depth * depth + random(10);
    else if (depth < 60)
      monsters[a].hpcap = depth * depth + random(depth);
    else
      monsters[a].hpcap = depth * 60 + random(depth);
    monsters[a].level = depth + random(depth/3);
    monsters[a].brains = random(6);
    if (depth < monsters[a].brains * 2)
      monsters[a].brains = 0;
    monsters[a].speed = random(7) + 20;
    monsters[a].type = random(12);
    if (monsters[a].type > 6)
      monsters[a].type = 0;
    if (depth < monsters[a].type * 2)
      monsters[a].type = 0;
    strcpy(monsters[a].monstername, prefix[monsters[a].type]);
    do {
      d = 1;
      b = random(18);
      for (e = 0;e < 5;e++)
      {
        if (b == used[e])
      	  d = 0;
      }
    } while (d == 0);
    used[a] = b;
    strcat(monsters[a].monstername, mname[b]);
    if (monsters[a].type == GIANT)
    {
      monsters[a].hpcap *= 2;
      monsters[a].level *= 2;
      monsters[a].speed = 28;
    }
    else if (monsters[a].type == UNDEAD)
      monsters[a].hpcap *= 3;
    else if (monsters[a].type == SKELETAL)
    {
      monsters[a].hpcap *= 5;
      monsters[a].level /= 2;
      monsters[a].speed += 2;
    }
    else if (monsters[a].type == DARK)
      monsters[a].level *= 5;
    else if (monsters[a].type == YOUNG)
    {
      monsters[a].hpcap /= 2;
      monsters[a].level /= 2;
      monsters[a].speed = 10;
    }
  }
  strcpy(monsters[5].monstername, "Iced Monster");
  monsters[5].hpcap = 1;
  monsters[5].level = 1;
  monsters[5].brains = 0;
  monsters[5].speed = 30;
  monsters[5].type = ICED;
}

void createitems(void)
{
  char in[60][18] = {{"Punch/Get        "}, {"Air Shall Erupt  "},
  {"Throw            "}, {"Search           "}, {"*Reason          "},
  {"*Threaten        "}, {"Sword of Justice "}, {"Dagger           "},
  {"Silver Dagger    "}, {"Short Sword      "}, {"Long Sword       "},
  {"Broad Sword      "}, {"Bow              "}, {"Longbow          "},
  {"Qvr/Wooden Arrows"}, {"Qvr/Silver Arrows"}, {"Qvr/Poison Arrows"},
  {"Aquacontrol      "}, {"Ruby Ring        "}, {"Mace             "},
  {"Gold Ring        "}, {"Silver Ring      "}, {"Leather armor    "},
  {"Chain mail       "}, {"Thin Plate       "}, {"Thick Plate      "},
  {"*Wieght of World "}, {"*Eternal Wound   "}, {"*Aim Shall Fail  "},
  {"*Foe's Aim True  "}, {"Arctic Wind      "}, {"*Sleep No More   "},
  {"*Instill Fear    "}, {"*Cure Curse      "}, {"Emerald Ring     "},
  {"*Heal            "}, {"Silver Flame     "}, {"Topaz Ring       "},
  {"*Magic Spores    "}, {"Moonstone Ring   "}, {"*Resurrect       "},
  {"Lightning        "}, {"Lense of Clarity "}, {"Magic Cloak      "},
  {"*Life is Finite  "}, {"Light of Glory   "}, {"Key              "},
  {"Lantern          "}, {"Tinder Box       "}, {"Oil              "},
  {"Torch            "}, {"Sappire Ring     "}, {"Sweet Rose       "},
  {"Shield           "}, {"Food             "}, {"Diamond Ring     "},
  {"Demon's Orb      "}, {"Map              "}, {"Amethyst Ring    "},
  {"Magic Potion     "}};
  int il[60][10] = {
  /*punch 0*/ {0, 1, 0, ACTION, 0, 0, 0, 1, 0, 0},
  /*air shall erupt 1*/ {0, 5, 0, ACTION, 3, 5, 1, 2, 0, 0},
  /*throw 2*/ {0, 1, 0, ACTION, 0, 0, 0, 2, 0, 0},
  /*examen 3*/ {0, 0, 0, ACTION, 0, 0, 0, 5, 0, 0},
  /*reason 4*/ {0, 0, 0, ACTION, 0, 0, 0, 4, WOWC, 0},
  /*threaten 5*/ {0, 0, 0, ACTION, 0, 0, 0, 4, IFC, 0},
  /*sword of justice 6*/ {0, 4, 1, WEAPON, 3, 30, 0, 1, 20, 0},
  /*dagger 7*/ {100, 3, 5, WEAPON, 1, 1, 0, 1, 0, 0},
  /*silver dagger 8*/ {300, 3, 7, WEAPON, 1, 5, 0, 1, WERE, 0},
  /*short sword 9*/ {700, 4, 10, WEAPON, 1, 10, 0, 1, 0, 0},
  /*long sword 10*/ {1000, 4, 15, WEAPON, 1, 20, 0, 1, 0, 0},
  /*broad sword 11*/ {1000, 6, 15, WEAPON, 1, 20, 0, 1, 0, 0},
  /*bow 12*/ {100, 1, 5, WEAPON, 1, 2, 0, 0, 120, 0},
  /*longbow 13*/ {3000, 2, 15, WEAPON, 1, 10, 0, 0, 120, 0},
  /*wooden arrow 14*/ {1, 2, 1, WEAPON, 1, 0, 0, 2, 0, 1},
  /*silver arrow 15*/ {10, 3, 1, WEAPON, 1, 0, 0, 2, WERE, 1},
  /*poison arrow 16*/ {20, 4, 1, WEAPON, 1, 0, 0, 2, 0, 1},
  /*control water 17*/ {2500, 2, 0, SPELL, 3, 25, 20, 5, 450, 0},
  /*ruby ring 18*/ {5000, 1, 1, RING, 2, 0, 0, 0, 0, 0},
  /*mace 19*/ {2000, 8, 10, WEAPON, 1, 30, 0, 0, 0, 0},
  /*gold ring 20*/ {5000, 2, 1, RING, 2, 0, 0, 0, 0, 0},
  /*silver ring 21*/ {5000, 1, 1, RING, 2, 0, 0, 0, 0, 0},
  /*leather armor 22*/ {100, 2, 5, ARMOR, 1, 0, 0, 0, 0, 0},
  /*chain mail 23*/ {500, 4,40, ARMOR, 1, 0, 0, 0, 0, 0},
  /*thin plate 24*/ {1000, 6, 70, ARMOR, 1, 0, 0, 0, 0, 0},
  /*thick plate 25*/ {3000, 8, 100, ARMOR, 1, 0, 0, 0, 0, 0},
  /*weight of world 26*/ {300, 1, 0, SPELL, 3, 5, 20, 4, WOWC, 0},
  /*eternal wound 27*/ {500, 1, 0, SPELL, 3, 10, 20, 4, EWC, 0},
  /*aim shall fail 28*/ {500, 1, 0, SPELL, 3, 20, 20, 4, ASFC, 0},
  /*foes's aim true 29*/ {500, 0, 0, SPELL, 3, 10, 20, 4, FATC, 0},
  /*Artic wind 30*/ {1000, 1, 0, SPELL, 3, 30, 1000, 5, 300, 0},
  /*insomnia 31*/ {5000, 1, 0, SPELL, 2, 20, 10, 4, FLC, 0},
  /*instill fear 32*/ {400, 1, 0, SPELL, 3, 10, 20, 4, IFC, 0},
  /*cure curse 33*/ {500, 1, 0, SPELL, 3, 1, 20, 4, NONE, 0},
  /*emerald ring 34*/ {5000, 1, 1, RING, 2, 0, 0, 0, 0, 0},
  /*heal 35*/ {100, 2, 0, SPELL, 3, 5, 10, 4, 40, 0},
  /*silver flame 36*/ {100, 7, 0, SPELL, 3, 10, 5, 2, WERE, 0},
  /*topaz ring 37*/ {5000, 1, 1, RING, 2, 0, 0, 0, 0, 0},
  /*magic spores 38*/ {5000, 8, 0, SPELL, 3, 15, 10, 4, 110, 0},
  /*moonstone ring 39*/ {5000, 1, 1, RING, 2, 0, 0, 0, 0, 0},
  /*resurrect 40*/ {100, 0, 0, SPELL, 3, 10, 20, 4, 60, 0},
  /*lightning 41*/ {1000, 300, 0, SPELL, 3, 20, 100, 3, 10, 0},
  /*lense of clarity 42*/ {500, 0, 5, EQUIPMENT, 2, 0, 0, 5, 1, 0},
  /*magic cloak 43*/ {0, 1, 1, ARMOR, 3, 30, 0, 0, 20, 0},
  /*life is finite 44*/ {5000, 0, 0, SPELL, 3, 10, 10, 4, 0, 0},
  /*light of glory 45*/ {2500, 0, 0, SPELL, 3, 15, 20, 5, 84, 0},
  /*key 46*/ {50, 0, 1, EQUIPMENT, 0, 0, 0, 1, 70, 1},
  /*lantern 47*/ {10, 0, 5, EQUIPMENT, 1, 0, 0, 6, 80, 0},
  /*tinder box 48*/ {10, 0, 3, EQUIPMENT, 1, 0, 0, 0, 81, 0},
  /*oil 49*/ {5, 1000, 3, EQUIPMENT, 1, 0, 0, 0, 82, 1},
  /*torch 50*/ {5, 200, 1, EQUIPMENT, 3, 0, 0, 1, 83, 0},
  /*sappire ring 51*/ {5000, 1, 1, RING, 2, 0, 0, 0, 0, 0},
  /*sweet rose 52*/ {3, 0, 1, EQUIPMENT, 3, 0, 0, 7, 90, 0},
  /*shield 53*/ {1000, 1, 40, WEAPON, 1, 0, 0, 1, 0, 0},
  /*food 54*/ {5, 10, 2, EQUIPMENT, 3, 0, 0, 0, 40, 1},
  /*diamond ring 55*/ {5000, 1, 1, RING, 3, 0, 0, 0, 100, 0},
  /*demon's orb 56*/ {15, 50, 5, EQUIPMENT, 3, 0, 0, 1, 110, 1},
  /*map 57*/ {10, 0, 1, EQUIPMENT, 4, 0, 0, 0, 0, 0},
  /*amethest ring 58*/ {5000, 1, 1, RING, 2, 0, 0, 0, 0, 0},
  /*magic potion 59*/ {50, 1, 5, EQUIPMENT, 1, 1, 0, 0, 0, 1},
  };
  for (int a = 0;a < 60;a++)
  {
    strcpy(itemlist[a].itemname, in[a]);
    itemlist[a].cost = il[a][0];
    itemlist[a].level = il[a][1];
    itemlist[a].weight = il[a][2];
    itemlist[a].iclass = il[a][3];
    itemlist[a].instock = il[a][4];
    itemlist[a].reqattr = il[a][5];
    itemlist[a].magic = il[a][6];
    itemlist[a].pattern = il[a][7];
    itemlist[a].special = il[a][8];
    itemlist[a].expend = il[a][9];
  }
}

void getpass(void)
{
  clrscr();
  cputs("Do you want password protection?(y/n)");
  if (getche() == 'y')
  {
    cputs("\r\nWhat password would you like?\r\n........................................");
    gotoxy(1, 3);
    getstr(&password, 40);
  }
  else
    strcpy(password, "");
  clrscr();
}

int savegame(void)
{
  FILE * outfile;
  for (int a = 0;a < 8;a++)
  {
    character[a].weight = 0;
    for (int b = 0;b < 60;b++)
    {
      for (int d = 0;d < character[a].number[b];d++)
      {
        if (character[a].inventory[b] != 100)
          character[a].weight += itemlist[character[a].inventory[b]].weight;
      }
    }
  }
  if ((outfile = fopen("charstat.dat", "wb")) == NULL)
    return 1;
  fwrite(character, sizeof(player), 8, outfile);
  fwrite(playkeys, sizeof(keys), 4, outfile);
  fwrite(&quicksaved, sizeof(int), 1, outfile);
  fwrite(password, sizeof(char), 41, outfile);
  fwrite(&gamespeed, sizeof(int), 1, outfile);
  fclose(outfile);
  return 0;
}

int loadgame(void)
{
  FILE * infile;
  if ((infile = fopen("charstat.dat", "rb")) == NULL)
    return 1;
  fread(character, sizeof(player), 8, infile);
  fread(playkeys, sizeof(keys), 4, infile);
  fread(&quicksaved, sizeof(int), 1, infile);
  fread(password, sizeof(char), 41, infile);
  fread(&gamespeed, sizeof(int), 1, infile);
  fclose(infile);
  return 0;
}

int quicksave(void)
{
  FILE * outfile;
  if ((outfile = fopen("quicksave.dat", "wb")) == NULL)
    return 1;
  fwrite(map, sizeof(room), 100, outfile);
  fwrite(doors, sizeof(int), 231, outfile);
  fwrite(pc, sizeof(ingameplay), 4, outfile);
  fwrite(&startx, sizeof(int), 1, outfile);
  fwrite(&starty, sizeof(int), 1, outfile);
  fwrite(rooms, sizeof(int), 8, outfile);
  fwrite(rdu, sizeof(int), 4, outfile);
  fwrite(&players, sizeof(int), 1, outfile);
  fwrite(c, sizeof(int), 4, outfile);
  fwrite(&depth, sizeof(int), 1, outfile);
  fwrite(themap, sizeof(int), 100, outfile);
  fwrite(gwall, sizeof(char), 320, outfile);
  fwrite(walls, sizeof(char), 40, outfile);
  fwrite(shots, sizeof(projectile), 36, outfile);
  fwrite(dungeonname, sizeof(char), 30, outfile);
  fwrite(mon, sizeof(ingamemon), 40, outfile);
  fwrite(monsters, sizeof(monster), 6, outfile);
  fwrite(floor, sizeof(int), 400, outfile);
  fwrite(&mysticx, sizeof(int), 1, outfile);
  fwrite(&mysticy, sizeof(int), 1, outfile);
  fclose(outfile);
  return 0;
}

int quickload(void)
{
  FILE * infile;
  if ((infile = fopen("quicksave.dat", "rb")) == NULL)
    return 1;
  fread(map, sizeof(room), 100, infile);
  fread(doors, sizeof(int), 231, infile);
  fread(pc, sizeof(ingameplay), 4, infile);
  fread(&startx, sizeof(int), 1, infile);
  fread(&starty, sizeof(int), 1, infile);
  fread(rooms, sizeof(int), 8, infile);
  fread(rdu, sizeof(int), 4, infile);
  fread(&players, sizeof(int), 1, infile);
  fread(c, sizeof(int), 4, infile);
  fread(&depth, sizeof(int), 1, infile);
  fread(themap, sizeof(int), 100, infile);
  fread(gwall, sizeof(char), 320, infile);
  fread(walls, sizeof(char), 40, infile);
  fread(shots, sizeof(projectile), 36, infile);
  fread(dungeonname, sizeof(char), 30, infile);
  fread(mon, sizeof(ingamemon), 40, infile);
  fread(monsters, sizeof(monster), 6, infile);
  fread(floor, sizeof(int), 400, infile);
  fread(&mysticx, sizeof(int), 1, infile);
  fread(&mysticy, sizeof(int), 1, infile);
  fclose(infile);
  for (int a = 0;a < 10;a++)
  {
    for (int b = 0;a < 10;a++)
      map[a][b].monstertype = &monsters[map[a][b].mtindex];
  }
  return 0;
}

void saveonechar(void)
{
  int a, b = -1;
  char fn[10] = {"charx.dat"};
  if (characters <= 0)
  {
    cputs("No characters.\r\n");
    return;
  }
  cprintf("\r\nSave which character? (");
  for (a = 0;a < 8;a++)
  {
    if (character[a].dead == 1)
      cprintf("%d,", a);
  }
  cprintf(" available.)");
  a = 8;
  do {
    cin >> a;
    cin.clear();
    if (a == 9)
      return;
  } while (character[a].dead == 0 || a > 7 || a < 0);
  cprintf("\r\n%s was chosen to be saved.", character[a].playername);
  cprintf("\r\nSave in which file? (0-7, 9 aborts) (No previous use checks are made!)");
  do {
    cin >> b;
    cin.clear();
    if (b == 9)
      return;
  } while (b > 7 || b < 0);
  fn[4] = (char)(b+48);
  FILE * outfile;
  if ((outfile = fopen(fn, "wb")) == NULL)
  {
    cprintf("Sorry, unable to save.");
    return;
  }
  fwrite(&character[a], sizeof(player), 1, outfile);
  fclose(outfile);
}

void loadonechar(void)
{
  int a, b = -1;
  char fn[10] = {"charx.dat"};
  if (characters >= 7)
  {
    cputs("Too many characters.\r\n");
    return;
  }
  cprintf("\r\nLoad into in what slot? (");
  for (a = 0;a < 8;a++)
  {
    if (character[a].dead == 0)
      cprintf("%d,", a);
  }
  cprintf(" available.)");
  a = 8;
  do {
    cin >> a;
    cin.clear();
    if (a == 9)
      return;
  } while (character[a].dead == 1 || a > 7 || a < 0);
  cprintf("\r\nLoad from which file? (0-7, 9 aborts)");
  do {
    cin >> b;
    cin.clear();
    if (b == 9)
      return;
  } while (b > 7 || b < 0);
  fn[4] = (char)(b+48);
  FILE * infile;
  if ((infile = fopen(fn, "rb")) == NULL)
  {
    cprintf("Sorry, unable to load.");
    return;
  }
  fread(&character[a], sizeof(player), 1, infile);
  fclose(infile);
  cprintf("\r\n%s was loaded as character %d.", character[a].playername, a);
}

void definekeys(void)
{
  for (int a = 0;a < 4;a++)
  {
    clrscr();
    cprintf("Define keys for player %d, (y)es/(n)o? ", a+1);
    if (getche() == (int)'y')
    {
      cputs("\r\npress key for up: ");
      while (kbhit() == 0);
      playkeys[a].up = getkey();
      cputs("\r\npress key for down: ");
      while (kbhit() == 0);
      playkeys[a].down = getkey();
      cputs("\r\npress key for right: ");
      while (kbhit() == 0);
      playkeys[a].right = getkey();
      cputs("\r\npress key for left: ");
      while (kbhit() == 0);
      playkeys[a].left = getkey();
      cputs("\r\npress key for right hand: ");
      while (kbhit() == 0);
      playkeys[a].rhand = getkey();
      cputs("\r\npress key for left hand: ");
      while (kbhit() == 0);
      playkeys[a].lhand = getkey();
      cputs("\r\npress key for menu: ");
      while (kbhit() == 0);
      playkeys[a].menu = getkey();
      cputs("\r\npress key for drop/change casting: ");
      while (kbhit() == 0);
      playkeys[a].drop = getkey();
    }
  }
  clrscr();
}

void humancon(int ckey, int charac)
{
  int dx = 0, dy = 0, a, b;
  int cx = 4, ox = 0, warp[4] = {21, 128, 21, 235}, frm = 0;
  int exchange[4][2] = {{10, 1}, {100, 10}, {1000, 100}, {10000, 1000}};
  if (ckey != NONE)
  {
    if (pc[charac].inmenu == 1 || pc[charac].inmenu == -1)
    {
      if ((IFC & character[c[charac]].cursed) == IFC)
      {
        switch (ckey)
        {
          case MUP: ckey = MDOWN; break;
          case MDOWN: ckey = MUP; break;
          case MRIGHT: ckey = MLEFT; break;
          case MLEFT: ckey = MRIGHT; break;
          case RHAND: ckey = LHAND; break;
          case LHAND: ckey = RHAND; break;
        }
      }
      if ((WOWC & character[c[charac]].cursed) == WOWC)
        a = 500;
      else
        a = 0;
      if (character[c[charac]].inventory[pc[charac].ring] == 58)
        b = 2;
      else
        b= 1;
      if ((random((character[c[charac]].weight + a) / b) + 1 <= (character[c[charac]].stamina * 10)))
      {
        if (ckey < RHAND)
        {
          if (ckey != pc[charac].facing)
	    pc[charac].facing = ckey;
	  else
	    pc[charac].moving = ckey;
        }
        else if (ckey == RHAND)
          useitem(character[c[charac]].inventory[pc[charac].rhand], character[c[charac]].inventory[pc[charac].lhand], charac, RHAND);
        else if (ckey == LHAND)
          useitem(character[c[charac]].inventory[pc[charac].lhand], character[c[charac]].inventory[pc[charac].rhand], charac, LHAND);
      }
      if (ckey == MENU)
      {
	pc[charac].mdx = pc[charac].mx = 0;
	pc[charac].mdy = pc[charac].my = 0;
	pc[charac].inmenu = -2;
      }
      else if (ckey == DROP)
      {
        if (++pc[charac].casting > 13)
          pc[charac].casting = 0;
        snd.copy(sblank, &sb);
        sb[0] = 1000;
        snd.copy(sb);
        pc[charac].upd |= UDMONEY;
      }
      switch (pc[charac].moving)
      {
        case MUP: dy = -1; break;
        case MDOWN: dy = 1; break;
        case MRIGHT: dx = 1; break;
        case MLEFT: dx = -1; break;
      }
      if (pc[charac].roomx == startx && pc[charac].roomy == starty && pc[charac].x + dx == 4 && pc[charac].y + dy == 4)
      {
        if (--players == 0)
          depth = 0;
        else
        {
          sellstuff(charac);
          character[c[charac]].playing = 0;
          rdu[pc[charac].rd]--;
          c[charac] = -1;
        }
        if (pc[charac].view == PLAYER1)
          window(1, 1, 40, 12);
        if (pc[charac].view == PLAYER2)
          window(41, 1, 80, 12);
        if (pc[charac].view == PLAYER3)
          window(1, 14, 40, 25);
        if (pc[charac].view == PLAYER4)
          window(41, 14, 80, 25);
        clrscr();
        pc[charac].control = STAND;
        pc[charac].view = NONE;
      }
      else if (pc[charac].roomx == mysticx && pc[charac].roomy == mysticy && pc[charac].x + dx == 4 && pc[charac].y + dy == 4)
      {
  snd.copy(sbolt);
  for (a = 0;a < 10;a++)
  {
    snd.play();
    delay(35);
    snd.pstop();
    delay(75);
  }
  snd.pstop(1);
  window(1,1,80,25);
  clrscr();
  gotoxy(1,1);
  textattr(LIGHTGRAY + (BLACK << 4));
  cprintf("Hello, %s, I am the Mystic One.\r\n", character[c[charac]].playername);
  cprintf("I will trade you one experience point for every $10 you give me.\r\n");
  cprintf("I have several rates of exchange.\r\n");
  cprintf("  $10    -> 1    exp.\r\n");
  cprintf("  $100   -> 10   exp.\r\n");
  cprintf("  $1000  -> 100  exp.\r\n");
  cprintf("  $10000 -> 1000 exp.\r\n");
  cprintf("  done");
  a = 0;
  cx = 4;
  frm = 0;
  while (a == 0)
  {
    if (cx < 4)
      cx = 8;
    else if (cx > 8)
      cx = 4;
    gotoxy(1, ox);
    putch(32);
    gotoxy(1, cx);
    ox = cx;
    putch(warp[frm++]);
    if (frm == 4)
      frm = 0;
    gotoxy(1,9);
    cprintf("$%d  exp. %d    ", character[c[charac]].money, character[c[charac]].experience);
    switch(getkey())
    {
      case UP: cx--; break;
      case DOWN: cx++; break;
      case SPACE: if (cx == 8)
                    a = 1;
                  else if (character[c[charac]].money >= exchange[cx-4][0])
                  {
                    character[c[charac]].money -= exchange[cx-4][0];
                    character[c[charac]].experience += exchange[cx-4][1];
                    if (character[c[charac]].experience > 30000)
                      character[c[charac]].experience = 30000;
                  }
                  break;
    }
    delay(100);
  }
        mysticx = -1;
        mysticy = -1;
        for (a = 0;a < 4;a++)
          pc[a].inmenu = -1;
        snd.copy(sbolt);
        clrscr();
      }
      if ((pc[charac].x + dx > 9) || (pc[charac].x + dx < 0) || (pc[charac].y + dy > 9) || (pc[charac].y + dy < 0))
      {
        checkdoor(&doors[pc[charac].roomx + doorx[pc[charac].moving-1]][pc[charac].roomy * 2 + doory[pc[charac].moving-1]], dx, dy, pc[charac].x, pc[charac].y, charac);
        dx = 0;
        dy = 0;
        gdoor(pc[charac].moving, charac);
        pc[charac].moving = 0;
      }
      for (a = 0;a < 4;a++)
      {
        if ((pc[charac].x + dx == pc[a].x) && (pc[charac].y + dy == pc[a].y) && (c[a] != -1) && (pc[charac].roomx == pc[a].roomx) && (pc[charac].roomy == pc[a].roomy) && character[c[a]].dead == 1 && character[c[a]].playing == 1)
	{
	  dx = 0;
	  dy = 0;
          pc[charac].moving = 0;
	}
      }
      for (a = 0;a < 10;a++)
      {
        if ((mon[pc[charac].rd][a].x == pc[charac].x + dx) && (mon[pc[charac].rd][a].y == pc[charac].y + dy) && mon[pc[charac].rd][a].hp > 0)
        {
          dx = 0;
          dy = 0;
          pc[charac].moving = 0;
        }
      }
      if ((map[pc[charac].roomx][pc[charac].roomy].torch != NOTORCH) && ((pc[charac].x + dx == 4) && (pc[charac].y + dy == 4)))
      {
        dx = 0;
        dy = 0;
        pc[charac].moving = 0;
      }
      a = floor[pc[charac].rd][pc[charac].x + dx][pc[charac].y + dy];
      if (a / 10 == SOLIDWALL/10 || a / 10 == CRUMBWALL/10)
      {
        if (a == CRUMBWALL+1)
        {
          b = 1;
          if (dy == 0)
          {
            if (pc[charac].x + dx != 0 && pc[charac].x + dx != 9)
              b = 0;
          }
          if (dx == 0)
          {
            if (pc[charac].y + dy != 0 && pc[charac].y + dy != 9)
              b = 0;
          }
          if (b == 0)
          {
              a = floor[pc[charac].rd][pc[charac].x + dx*2][pc[charac].y + dy*2];
              if (a/10 != CHEST/10 && a/10 != TCHEST/10 && a/10 != CRUMBWALL/10 && a/10 != SOLIDWALL/10)
              {
                b = 0;
                for (a = 0;a < 10;a++)
                {
                  if (mon[pc[charac].rd][a].hp > 0 && mon[pc[charac].rd][a].x == pc[charac].x + dx*2 && mon[pc[charac].rd][a].y == pc[charac].y + dy*2)
                    b = 1;
                }
                if (b != 1)
                {
                  floor[pc[charac].rd][pc[charac].x+dx*2][pc[charac].y+dy*2] = floor[pc[charac].rd][pc[charac].x+dx][pc[charac].y+dy];
                  floor[pc[charac].rd][pc[charac].x+dx][pc[charac].y+dy] = TILE + random(3) + 1;
                }
                else
                {
                  dx = 0;
                  dy = 0;
                  pc[charac].moving = 0;
                }
              }
              else
              {
                dx = 0;
                dy = 0;
                pc[charac].moving = 0;
              }
            snd.copy(sblank, &sb);
            sb[0] = 150;
            sb[1] = 150;
            sb[2] = 150;
            snd.copy(sb);
          }
          else
          {
            dx = 0;
            dy = 0;
            pc[charac].moving = 0;
          }
        }
        else
        {
          dx = 0;
          dy = 0;
          pc[charac].moving = 0;
        }
      }
      if (floor[pc[charac].rd][pc[charac].x + dx][pc[charac].y + dy] / 10 == CLEARH2O/10)
        floor[pc[charac].rd][pc[charac].x + dx][pc[charac].y + dy] += MUDDYH2O-CLEARH2O;
      if (floor[pc[charac].rd][pc[charac].x + dx][pc[charac].y + dy] / 10 == TRAP/10 || floor[pc[charac].rd][pc[charac].x + dx][pc[charac].y + dy] / 10 == TCHEST/10)
      {
        if (random(200) > character[c[charac]].luck && character[c[charac]].inventory[pc[charac].rhand] != 52 && character[c[charac]].inventory[pc[charac].lhand] != 52)
        {
          pc[charac].hp -= random(5 * depth);
          pc[charac].upd = pc[charac].upd | UDHP;
          pc[charac].hit = 1;
          snd.copy(splayhit);
        }
        else
          snd.copy(scure);
        if (floor[pc[charac].rd][pc[charac].x + dx][pc[charac].y + dy] / 10 == TRAP/10)
        {
          map[pc[charac].roomx][pc[charac].roomy].traps--;
          floor[pc[charac].rd][pc[charac].x + dx][pc[charac].y + dy] -= TRAP;
          if (floor[pc[charac].rd][pc[charac].x + dx][pc[charac].y + dy] % 10 == TILE)
            floor[pc[charac].rd][pc[charac].x + dx][pc[charac].y + dy] += TILE + random(3) + 1;
        }
        else
          floor[pc[charac].rd][pc[charac].x + dx][pc[charac].y + dy] = CHEST;
      }
      if (pc[charac].hp <= 0 && character[c[charac]].dead == 1)
      {
        players--;
        character[c[charac]].dead = 0;
      }
      if (floor[pc[charac].rd][pc[charac].x + dx][pc[charac].y + dy] / 10 == CHEST/10)
      {
        checkchest(pc[charac].rd, dx, dy, pc[charac].x, pc[charac].y, character[c[charac]].dexterity);
        dx = 0;
        dy = 0;
        pc[charac].moving = 0;
      }
      if (pc[charac].moving != NONE)
      {
        snd.copy(sblank, &sb);
        if (floor[pc[charac].rd][pc[charac].x][pc[charac].y]/10 == CLEARH2O/10 || floor[pc[charac].rd][pc[charac].x][pc[charac].y]/10 == MUDDYH2O/10)
        {
          sb[0] = 300;
          sb[1] = 350;
        }
        else
          sb[0] = 200;
        snd.copy(sb);
      }
      pc[charac].x += dx;
      pc[charac].y += dy;
      pc[charac].moving = NONE;
    }
    else if (pc[charac].inmenu == 2 || pc[charac].inmenu == -2)
    {
      if (ckey < RHAND)
      {
        snd.copy(sblank, &sb);
        sb[0] = 700;
        snd.copy(sb);
        pc[charac].dropping = 0;
      }
      else if (ckey == RHAND || ckey == LHAND)
      {
        snd.copy(sblank, &sb);
        sb[0] = 1000;
        snd.copy(sb);
        pc[charac].dropping = 0;
      }
      else if (ckey == DROP)
      {
        if (pc[charac].dropping == 1)
          snd.copy(sdrop);
        else
        {
          snd.copy(sblank, &sb);
          sb[0] = 1000;
         snd.copy(sb);
        }
      }
      if (ckey == MUP)
	(pc[charac].my == 0) ? (pc[charac].mdy = 9) : (pc[charac].mdy = -1);
      else if (ckey == MDOWN)
	(pc[charac].my == 9) ? (pc[charac].mdy = -9) : (pc[charac].mdy = 1);
      else if (ckey == MRIGHT)
      {
	(pc[charac].mx >= 5) ? (pc[charac].mdx = -5) : (pc[charac].mdx = 1);
        if (character[c[charac]].inventory[(pc[charac].mx + pc[charac].mdx) * 10] == 100)
          pc[charac].mdx = pc[charac].mx * -1;
      }
      else if (ckey == MLEFT)
      {
	(pc[charac].mx <= 0) ? (pc[charac].mdx = 5) : (pc[charac].mdx = -1);
        while (character[c[charac]].inventory[(pc[charac].mx + pc[charac].mdx) * 10] == 100)
          pc[charac].mdx--;
      }
      else if (ckey == RHAND && character[c[charac]].inventory[pc[charac].my + pc[charac].mx * 10] != 100)
      {
        if (pc[charac].rhand == 47)
          pc[charac].lanlit = 0;
        else if (pc[charac].rhand == 50)
          pc[charac].torchlit = 0;
	if (itemlist[character[c[charac]].inventory[pc[charac].my + pc[charac].mx * 10]].iclass == ARMOR)
        {
  	  if (pc[charac].my + pc[charac].mx * 10 != pc[charac].wearing)
	    pc[charac].newwear = pc[charac].my + pc[charac].mx * 10;
          else
            pc[charac].newwear = 0;
        }
	else if (itemlist[character[c[charac]].inventory[pc[charac].my + pc[charac].mx * 10]].iclass == RING)
        {
  	  if (pc[charac].my + pc[charac].mx * 10 != pc[charac].ring)
	    pc[charac].newring = pc[charac].my + pc[charac].mx * 10;
          else
            pc[charac].newring = 0;
        }
	else
	  pc[charac].newright = pc[charac].my + pc[charac].mx * 10;
      }
      else if (ckey == LHAND && character[c[charac]].inventory[pc[charac].my + pc[charac].mx * 10] != 100)
      {
        if (pc[charac].lhand == 47)
          pc[charac].lanlit = 0;
        else if (pc[charac].lhand == 50)
          pc[charac].torchlit = 0;
	pc[charac].newleft = pc[charac].my + pc[charac].mx * 10;
      }
      else if (ckey == DROP)
      {
        if (pc[charac].dropping == 0)
           pc[charac].dropping = 1;
        else
        {
        b = pc[charac].my + pc[charac].mx * 10;
        if (b > 5 && character[c[charac]].inventory[b] != 100)
        {
          a = character[c[charac]].number[b];
          while (a-- > 0)
            removeitem(c[charac], b);
          shift(charac, b);
          pc[charac].inmenu = -2;
        }
        pc[charac].dropping = 0;
        }
      }
      else if (ckey == MENU)
      {
	pc[charac].inmenu = -1;
        pc[charac].dropping = 0;
      }
    }
    else if (pc[charac].inmenu == 4)
    {
      if (ckey != NONE)
        pc[charac].inmenu = -1;
    }
    else
      pc[charac].inmenu = -1;
  }
  if (pc[charac].inmenu < 0 && snd.nplay() == 0)
  {
    snd.copy(sblank, &sb);
    sb[0] = 500;
    snd.copy(sb);
  }
      if (floor[pc[charac].rd][pc[charac].x][pc[charac].y] / 10 == FIRE/10)
      {
        pc[charac].hp -= depth;
        pc[charac].upd = pc[charac].upd | UDHP;
        pc[charac].hit = 1;
        snd.copy(splayhit);
      }
}

void checkchest(int rd, int edx, int edy, int ex, int ey, int lev)
{
  int a, b;
  if (floor[rd][ex + edx][ey + edy] % 10 != 0)
    floor[rd][ex + edx][ey + edy] = CHEST;
  else if (random(200) <= lev)
  {
    map[rooms[rd][X]][rooms[rd][Y]].goodies += (b = random(5) + 1);
    map[rooms[rd][X]][rooms[rd][Y]].chests--;
    floor[rd][ex + edx][ey + edy] = random(3) + 1;
    for (a = 0;a < b;a++)
      makegoody(rd, ex+(random(3)-1), ey+(random(3)-1));
    for (a = 0;a < 10;a++)
      sb[a] = random(5000) + 2000;
    snd.copy(sb);
  }
}

void checkdoor(int *thedoor, int ex, int ey, int x, int y, int ch, int hit)
{
  if (*thedoor != SOLID)
  {
    if (*thedoor / 10 == NOWALL / 10)
      trydoor(thedoor, ex, ey, ch, hit);
    else
    {
      if (ex == 0 && x == 4)
        trydoor(thedoor, ex, ey, ch, hit);
      else if (ey == 0 && y == 4)
        trydoor(thedoor, ex, ey, ch, hit);
    }
  }
  for (int a = 0;a < 11;a++)
  {
    for (int b = 0;b < 21;b++)
      dcopy[a][b] = doors[a][b];
  }
}

void trydoor(int *thedoor, int ex, int ey, int ch, int hit)
{
  int b;
  if (*thedoor%10 == OPEN && hit == -1)
  {
    if (ex == 0)
    {
      if (ey == -1)
        pc[ch].fy = pc[ch].y = 9;
      else
        pc[ch].fy = pc[ch].y = 0;
      pc[ch].fx = pc[ch].x;
      pc[ch].roomy += ey;
    }
    else
    {
      if (ex == -1)
        pc[ch].fx = pc[ch].x = 9;
      else
        pc[ch].fx = pc[ch].x = 0;
      pc[ch].fy = pc[ch].y;
      pc[ch].roomx += ex;
    }
    if (rdu[pc[ch].rd] - 1 != 0)
    {
      rdu[pc[ch].rd]--;
      for (b = 0;b < map[pc[ch].roomx-ex][pc[ch].roomy-ey].monsters;b++)
        mon[pc[ch].rd][b].target = -1;
      pc[ch].rd = -1;
      while (rdu[++pc[ch].rd] != 0)
        ;
      rdu[pc[ch].rd] = 1;
      createroom(ch, pc[ch].roomx, pc[ch].roomy);
      pc[ch].inmenu = -1;
    }
    else
    {
      createroom(ch, pc[ch].roomx, pc[ch].roomy);
      pc[ch].inmenu = -1;
    }
    for (int a = 0;a < 4;a++)
    {
      if (pc[ch].roomx == pc[a].roomx && pc[ch].roomy == pc[a].roomy && ch != a && character[c[a]].playing == 1)
      {
        rdu[pc[ch].rd] = 0;
        pc[ch].rd = pc[a].rd;
        rdu[pc[ch].rd]++;
        for (int b = 1;b < 5;b++)
          gdoor(b, ch);
        for (b = 0;b < 10;b++)
          mon[pc[ch].rd][b].target = -1;
        break;
      }
    }
    for (a = 0;a < 4;a++)
    {
      if (rdu[a] == 0)
      {
        for (b = 0;b < 10;b++)
          mon[a][b].hp = 0;
      }
    }
  }
  else
  {
    if (hit == -1)
    {
    if (*thedoor % 2 == SECRET)
    {
      if ((random(character[c[ch]].intelligence + 10) - random(character[c[ch]].luck / 2)) <= character[c[ch]].intelligence)
        *thedoor -= SECRET;
    }
    else if (*thedoor % 10 > HARD)
    {
      if ((random(character[c[ch]].dexterity + 200) - random(character[c[ch]].luck / 3)) <= character[c[ch]].dexterity)
        *thedoor -= LOCKED;
    }
    else if (*thedoor % 10 == EASY)
      *thedoor -= EASY;
    else if (*thedoor % 10 == HARD)
    {
      if (*thedoor / 10 == WOOD / 10)
        if (random((character[c[ch]].strength + 10) - random(character[c[ch]].luck / 3)) <= character[c[ch]].strength)
          *thedoor -= HARD;
      if (*thedoor / 10 == STONE / 10 || *thedoor / 10 == NOWALL /10)
        if (random((character[c[ch]].strength + 20) - random(character[c[ch]].luck / 3)) <= character[c[ch]].strength)
          *thedoor -= HARD;
      if (*thedoor / 10 == GRATE / 10)
        if (random((character[c[ch]].strength + 40) - random(character[c[ch]].luck / 3)) <= character[c[ch]].strength)
          *thedoor -= HARD;
      if (*thedoor / 10 == STEEL / 10)
        if (random((character[c[ch]].strength + 60) - random(character[c[ch]].luck / 3)) <= character[c[ch]].strength)
          *thedoor -= HARD;
    }
    }
    else
    {
    if (*thedoor % 2 == SECRET)
    {
      if (random(200) <= hit)
        *thedoor -= SECRET;
    }
    else if (*thedoor % 10 > HARD)
    {
      if (random(1200) <= hit)
        *thedoor -= LOCKED;
    }
    else if (*thedoor % 10 == EASY)
      *thedoor -= EASY;
    else if (*thedoor % 10 == HARD)
    {
      if (*thedoor / 10 == WOOD / 10)
        if (random(100) <= hit)
          *thedoor -= HARD;
      if (*thedoor / 10 == STONE / 10 || *thedoor / 10 == NOWALL /10)
        if (random(200) <= hit)
          *thedoor -= HARD;
      if (*thedoor / 10 == GRATE / 10)
        if (random(800) <= hit)
          *thedoor -= HARD;
      if (*thedoor / 10 == STEEL / 10)
        if (random(1200) <= hit)
          *thedoor -= HARD;
    }
    }
  }
}

void useitem(int touse, int ohand, int u, int whand)
{
   int projec[9], udx = 0, udy = 0, a, b, e, d, r, *hp, hpcap, tx, ty, use = 1;
   char *cursed;
   if (pc[u].casting >= 10)
   {
     hp = &pc[pc[u].casting-10].hp;
     hpcap = character[c[pc[u].casting-10]].hpcap;
     cursed = &character[c[pc[u].casting-10]].cursed;
     tx = pc[pc[u].casting-10].x;
     ty = pc[u].y;
   }
   else
   {
     hp = &mon[pc[u].rd][pc[u].casting].hp;
     hpcap = map[pc[u].roomx][pc[u].roomy].monstertype->hpcap;
     cursed = &mon[pc[u].rd][pc[u].casting].cursed;
     tx = mon[pc[u].rd][pc[u].casting].x;
     ty = mon[pc[u].rd][pc[u].casting].y;
   }
   if (itemlist[touse].special == 120 && ohand >= 14 && ohand <= 16)
   {
     a = touse;
     touse = ohand;
     ohand = a;
     (whand == RHAND) ? (whand = LHAND) : (whand = RHAND);
   }
   switch (pc[u].facing)
   {
     case MUP: udy = -1; break;
     case MDOWN: udy = 1; break;
     case MRIGHT: udx = 1; break;
     case MLEFT: udx = -1; break;
   }
   if (character[c[u]].inventory[pc[u].ring] == 20)
     r = 2;
   else
     r = 1;
   if (itemlist[touse].magic <= pc[u].mp)
   {
   switch (itemlist[touse].iclass)
   {
     case WEAPON: if (itemlist[ohand].special == 120 && itemlist[ohand].reqattr <= character[c[u]].strength && touse >= 14 && touse <= 16)
                  {
                    if (--character[c[u]].arrows[touse-14] > 0)
                      use = 0;
                    findfree(&projec, 1);
                    switch (touse)
                    {
                      case 14: e = BROWN; break;
                      case 15: e = WHITE; break;
                      case 16: e = BLACK; break;
                    }
                    if (pc[u].facing < MRIGHT)
                      b = 179;
                    else
                      b = 196;
                    sc(projec[0], pc[u].x, pc[u].y, pc[u].facing, itemlist[touse].level * character[c[u]].strength * itemlist[touse].level * r, 12, itemlist[touse].special, u+10, pc[u].rd, e, b, b, b, b);
                    snd.copy(sswish);
                  }
                  else if (((character[c[u]].strength >= itemlist[touse].reqattr && touse != 6) || (character[c[u]].morality >= itemlist[touse].reqattr && touse == 6)) && (touse > 16 || touse < 14) && touse != 53 && itemlist[touse].special != 120)
                  {
                    findfree(&projec, 3);
                    switch (pc[u].facing)
                    {
                      case MUP: b = 25; break;
                      case MDOWN: b = 24; break;
                      case MRIGHT: b = 27; break;
                      case MLEFT: b = 26; break;
                    }
                    if (pc[u].facing < MRIGHT)
                      d = 179;
                    else
                      d = 196;
                    if (itemlist[touse].special == WERE)
                      e = WHITE;
                    else
                      e = DARKGRAY;
                    if (touse != 6 || (touse == 6 && itemlist[touse].reqattr <= character[c[u]].morality))
                    {
                    sc(projec[0], pc[u].x, pc[u].y, pc[u].facing, itemlist[touse].level * character[c[u]].strength * r, 1, itemlist[touse].special, u+10, pc[u].rd, e, b, b, b, b);
                    if (touse == 10)
                    {
                      sc(projec[1], pc[u].x + udx, pc[u].y + udy, pc[u].facing, itemlist[touse].level * character[c[u]].strength * r, 1, itemlist[touse].special, u+10, pc[u].rd, e, d, d, d, d);
                      sc(projec[2], pc[u].x + udx * 2, pc[u].y + udy * 2, pc[u].facing, itemlist[touse].level * character[c[u]].strength * r, 1, itemlist[touse].special, u+10, pc[u].rd, e, d, d, d, d);
                    }
                    else if (touse == 19)
                    {
                      sc(projec[1], pc[u].x + udx, pc[u].y + udy, pc[u].facing, itemlist[touse].level * character[c[u]].strength * r, 1, itemlist[touse].special, u+10, pc[u].rd, e, 15, 15, 15, 15);
                      shots[projec[2]].lifespan = 0;
                    }
                    else if (touse == 6)
                    {
                      sc(projec[1], pc[u].x + udx, pc[u].y + udy, pc[u].facing, itemlist[touse].level * character[c[u]].strength * r, 1, itemlist[touse].special, u+10, pc[u].rd, e, d, d, d, d);
                      shots[projec[2]].lifespan = 0;
                    }
                    else
                    {
                      shots[projec[1]].lifespan = 0;
                      shots[projec[2]].lifespan = 0;
                    }
                    snd.copy(sswish);
                    }
                  }
                  else if (touse == 53)
                  {
                    pc[u].inaction = 14;
                    snd.copy(sswish);
                  }
                  else
                    use = 0;
                  break;
     case SPELL: if (itemlist[touse].magic <= pc[u].mp && itemlist[touse].reqattr <= character[c[u]].magic)
                 {
                   if (itemlist[touse].pattern == 4)
                   {
                     a = map[pc[u].roomx][pc[u].roomy].monstertype->type;
                     if (touse == 35 && (pc[u].casting >= 10 || (pc[u].casting < 10 && mon[pc[u].rd][pc[u].casting].hp > 0)))
                     {
                       *hp += character[c[u]].magic * itemlist[touse].level;
                       if (*hp > hpcap)
                         *hp = hpcap;
                       for (b = 0;b < 4;b++)
                         pc[b].upd |= UDHP;
                       snd.copy(sheal);
                     }
                     else if (touse == 38)
                     {
                       if (tx < 9)
                         b = 1;
                       else
                         b = 0;
                       if (tx > 0)
                         d = 1;
                       else
                         d = 0;
                       if (ty < 9)
                         e = 1;
                       else
                         e = 0;
                       if (ty > 0)
                         r = 1;
                       else
                         r = 0;
                       if (b == 1)
                       {
                         floor[pc[u].rd][tx+1][ty] = TRAP;
                         map[pc[u].roomx][pc[u].roomy].traps++;
                       }
                       if (b == 1 && e == 1)
                       {
                         floor[pc[u].rd][tx+1][ty+1] = TRAP;
                         map[pc[u].roomx][pc[u].roomy].traps++;
                       }
                       if (e == 1)
                       {
                         floor[pc[u].rd][tx][ty+1] = TRAP;
                         map[pc[u].roomx][pc[u].roomy].traps++;
                       }
                       if (e == 1 && d == 1)
                       {
                         floor[pc[u].rd][tx-1][ty+1] = TRAP;
                         map[pc[u].roomx][pc[u].roomy].traps++;
                       }
                       if (d == 1)
                       {
                         floor[pc[u].rd][tx-1][ty] = TRAP;
                         map[pc[u].roomx][pc[u].roomy].traps++;
                       }
                       if (d == 1 && r == 1)
                       {
                         floor[pc[u].rd][tx-1][ty-1] = TRAP;
                         map[pc[u].roomx][pc[u].roomy].traps++;
                       }
                       if (r == 1)
                       {
                         floor[pc[u].rd][tx][ty-1] = TRAP;
                         map[pc[u].roomx][pc[u].roomy].traps++;
                       }
                       if (r == 1 && b == 1)
                       {
                         floor[pc[u].rd][tx+1][ty-1] = TRAP;
                         map[pc[u].roomx][pc[u].roomy].traps++;
                       }
                       snd.copy(scurse);
                     }
                     else if (touse == 40)
                     {
                       if (pc[u].casting >= 10 && character[c[pc[u].casting-10]].playing == 1)
                       {
                         character[c[pc[u].casting-10]].dead = 1;
                         pc[pc[u].casting-10].hp = 5;
                         for (b = 0;b < 4;b++)
                           pc[b].upd |= UDHP;
                         players++;
                       }
                       snd.copy(scure);
                     }
                     else if (touse == 44 && pc[u].casting < 10 && mon[pc[u].rd][pc[u].casting].hp > 0 && (a == UNDEAD || a == SKELETAL))
                     {
                       findfree(&projec, 1);
                       sc(projec[0], mon[pc[u].rd][pc[u].casting].x, mon[pc[u].rd][pc[u].casting].y, 0, 0, 8, 0, u+10, pc[u].rd, MAGENTA, 176, 177, 178, 177);
                       mon[pc[u].rd][pc[u].casting].hp = 0;
                       makegoody(pc[u].rd, mon[pc[u].rd][pc[u].casting].x, mon[pc[u].rd][pc[u].casting].y);
                       character[c[u]].experience += map[pc[u].roomx][pc[u].roomy].monstertype->level;
                       map[pc[u].roomx][pc[u].roomy].monsters--;
                       map[pc[u].roomx][pc[u].roomy].goodies++;
                       pc[u].upd |= UDEXPER;
                       snd.copy(sdead);
                     }
                     else if (touse == 33)
                     {
                       *cursed = NONE;
                       for (b = 0;b < 4;b++)
                         pc[b].upd |= UDCURSE;
                       snd.copy(scure);
                     }
                     else if ((map[pc[u].roomx][pc[u].roomy].monstertype->type != SKELETAL && pc[u].casting < 10) || (pc[u].casting >= 10 && pc[pc[u].casting-10].ring != 51))
                     {
                       if (character[c[u]].inventory[pc[u].ring] == 39 && pc[u].mp >= itemlist[touse].magic)
                       {
                         for (a = 0;a < 10;a++)
                         {
                           if (mon[pc[u].rd][a].hp > 0)
                             mon[pc[u].rd][a].cursed |= (char)itemlist[touse].special;
                         }
                         use = 0;
                       }
                       else
                         *cursed |= (char)itemlist[touse].special;
                       snd.copy(scurse);
                     }
                     if (touse == 31 && pc[u].casting >= 10)
                     {
                       pc[u].fx = pc[pc[u].casting-10].x;
                       pc[u].fy = pc[pc[u].casting-10].y;
                     }
                     if (pc[u].casting >= 10)
                     {
                       for (b = 0;b < 4;b++)
                         pc[b].upd = pc[b].upd | UDCURSE | UDWEIGHT;
                     }
                   }
                   else if (touse == 17)
                   {
                     map[pc[u].roomx][pc[u].roomy].flooded = !map[pc[u].roomx][pc[u].roomy].flooded;
                     floor[pc[u].rd][pc[u].x][pc[u].y] = CLEARH2O;
                     if (map[pc[u].roomx][pc[u].roomy].flooded)
                       snd.copy(scure);
                     else
                       snd.copy(scurse);
                   }
                   else if (touse == 45)
                   {
                     map[pc[u].roomx][pc[u].roomy].torch = LIT;
                     snd.copy(slight);
                   }
                   else if (touse == 30)
                   {
                     map[pc[u].roomx][pc[u].roomy].monstertype = &monsters[5];
                     for (a = 0;a < 10;a++)
                     {
                       if (mon[pc[u].rd][a].hp > 0)
                         mon[pc[u].rd][a].hp = 1;
                     }
                     pc[u].inmenu = -1;
                     snd.copy(swind, &sb);
                     for (e = 3;e < 10;e++)
                       sb[e] = random(5000) + 2000;
                     snd.copy(sb);
                   }
                   else if (touse == 36)
                   {
                     findfree(&projec, 1);
                     sc(projec[0], pc[u].x, pc[u].y, pc[u].facing, 7 * character[c[u]].magic, 12, WERE, u+10, pc[u].rd, WHITE, 176, 177, 178, 177);
                     snd.copy(smagic);
                   }
                   else if (touse == 41)
                   {
                     pc[u].inaction = 9;
                     snd.copy(sbolt);
                   }
                 }
                 else
                   use = 0;
                 break;
     case EQUIPMENT: if (touse == 46)
                     {
                       d = 0;
                       if (pc[u].x == 4 || pc[u].y == 4)
                       {
                         e = 0;
                         if (pc[u].x == 0 && pc[u].facing == MLEFT)
                           e = MLEFT-1;
                         else if (pc[u].x == 9 && pc[u].facing == MRIGHT)
                           e = MRIGHT-1;
                         else if (pc[u].y == 9 && pc[u].facing == MDOWN)
                           e = MDOWN-1;
                         else if (pc[u].y == 0 && pc[u].facing == MUP)
                           e = MUP-1;
                         else
                           use = 0;
                         if (use == 1 && doors[pc[u].roomx + doorx[e]][pc[u].roomy * 2 + doory[e]] % 10 > HARD + SECRET)
                         {
                           doors[pc[u].roomx + doorx[e]][pc[u].roomy * 2 + doory[e]] -= LOCKED;
                           d = 1;
                         }
                         gdoor(e+1, u);
                         snd.copy(sboom);
                       }
                       if (d == 0 && floor[pc[u].rd][pc[u].x+udx][pc[u].y+udy] == CHEST || floor[pc[u].rd][pc[u].x+udx][pc[u].y+udy] == TCHEST)
                       {
                         checkchest(pc[u].rd, udx, udy, pc[u].x, pc[u].y, 500);
                         use = 1;
                       }
                       else if (d == 0)
                         use = 0;
                     }
                     else if (touse == 42)
                     {
                       for (e = 0;e < 4;e++)
                       {
                         if (doors[pc[u].roomx + doorx[e]][pc[u].roomy * 2 + doory[e]] % 2 == SECRET)
                         {
                           doors[pc[u].roomx + doorx[e]][pc[u].roomy * 2 + doory[e]] -= SECRET;
                           snd.copy(sfind);
                         }
                         gdoor(e+1, u);
                       }
                       for (a = 0;a < 10;a++)
                       {
                         for (b = 0;b < 10;b++)
                         {
                           if (floor[pc[u].rd][a][b] % 10 > TILE && floor[pc[u].rd][a][b]/10 != TILE && floor[pc[u].rd][a][b]/10 < CLEARH2O/10)
                           {
                             floor[pc[u].rd][a][b] -= floor[pc[u].rd][a][b] % 10;
                             snd.copy(sfind);
                           }
                         }
                       }
                     }
                     else if (touse == 48)
                     {
                       if (pc[u].x + udx == 4 && pc[u].y + udy == 4 && map[pc[u].roomx][pc[u].roomy].torch == UNLIT)
                         map[pc[u].roomx][pc[u].roomy].torch = LIT;
                       else if (floor[pc[u].rd][pc[u].x + udx][pc[u].y + udy] / 10 == TRAP/10)
                       {
                         floor[pc[u].rd][pc[u].x + udx][pc[u].y + udy] = FIRE;
                         map[pc[u].roomx][pc[u].roomy].fire++;
                         map[pc[u].roomx][pc[u].roomy].traps--;
                       }
                       else if (ohand == 47 && character[c[u]].oillight > 0)
                         pc[u].lanlit = LIT;
                       else if (ohand == 50 && character[c[u]].torchlight > 0)
                         pc[u].torchlit = LIT;
                       snd.copy(slight);
                     }
                     else if (touse == 49)
                     {
                       if (character[c[u]].oillight <= 0)
                         character[c[u]].oillight = itemlist[touse].level;
                       else
                         use = 0;
                     }
                     else if (touse == 50)
                     {
                       findfree(&projec, 1);
                       if (pc[u].facing < MRIGHT)
                         d = 179;
                       else
                         d = 196;
                       sc(projec[0], pc[u].x, pc[u].y, pc[u].facing, 2 * character[c[u]].strength * r, 1, 0, u+10, pc[u].rd, BROWN, d, d, d, d);
                       snd.copy(sswish);
                     }
                     else if (touse == 54)
                     {
                       pc[u].hp += itemlist[touse].level;
                       if (pc[u].hp > character[c[u]].hpcap)
                         pc[u].hp = character[c[u]].hpcap;
                       pc[u].upd |= UDHP;
                       snd.copy(sheal);
                     }
                     else if (touse == 56)
                     {
                       findfree(&projec, 1);
                       sc(projec[0], pc[u].x+udx, pc[u].y+udy, NONE, 0, 10, itemlist[touse].special, u+10, pc[u].rd, DARKGRAY, 229, 229, 229, 229);
                       snd.copy(sblank, &sb);
                       sb[0] = 100;
                       snd.copy(sb);
                     }
                     else if (touse == 57)
                     {
                       pc[u].inmenu = 4;
                       snd.copy(sblank, &sb);
                       sb[0] = 500;
                       snd.copy(sb);
                     }
                     else if (touse == 59)
                     {
                       pc[u].mp = character[c[u]].mpcap;
                       snd.copy(scure);
                     }
                     else
                       use = 0;
     case ACTION: if (touse == 0)
                  {
                    findfree(&projec, 1);
                    switch (pc[u].facing)
                    {
                      case MUP: b = 220; break;
                      case MDOWN: b = 223; break;
                      case MRIGHT: b = 221; break;
                      case MLEFT: b = 222; break;
                    }
                    sc(projec[0], pc[u].x, pc[u].y, pc[u].facing, itemlist[touse].level * character[c[u]].strength * r, 1, itemlist[touse].special, u+10, pc[u].rd, BROWN, b, b, b, b);
                    snd.copy(sswish);
                    if (pc[u].x+udx >= 0 && pc[u].x+udx <= 9 && pc[u].y+udy >= 0 && pc[u].y+udy <= 9)
                    {
                      use = 0;
                      if (floor[pc[u].rd][pc[u].x + udx][pc[u].y + udy] == MONEY)
                      {
                        character[c[u]].money += random(depth) + random(character[c[u]].luck) + 1;
                        floor[pc[u].rd][pc[u].x + udx][pc[u].y + udy] = TILE + random(3) + 1;
                        map[pc[u].roomx][pc[u].roomy].goodies--;
                        pc[u].upd |= UDMONEY;
                      }
                      else if (floor[pc[u].rd][pc[u].x + udx][pc[u].y + udy] == MAGIC)
                      {
                        pc[u].mp += (random(depth) + random(character[c[u]].luck + 1)) * 2 + 1;
                        if (pc[u].mp >= character[c[u]].mpcap)
                          pc[u].mp = character[c[u]].mpcap;
                        floor[pc[u].rd][pc[u].x + udx][pc[u].y + udy] = TILE + random(3) + 1;
                        map[pc[u].roomx][pc[u].roomy].goodies--;
                      }
                      else if (floor[pc[u].rd][pc[u].x + udx][pc[u].y + udy]/10 == CLEARH2O/10)
                      {
                        if (random(200) < character[c[u]].luck)
                        {
                          pc[u].hp++;
                          snd.copy(sheal);
                        }
                        if (pc[u].hp >= character[c[u]].hpcap)
                          pc[u].hp = character[c[u]].hpcap;
                        floor[pc[u].rd][pc[u].x + udx][pc[u].y + udy] = TILE + random(3) + 1;
                        pc[u].upd |= UDHP;
                      }
                      else if (floor[pc[u].rd][pc[u].x + udx][pc[u].y + udy]/10 == MUDDYH2O/10)
                      {
                        if (random(200) > character[c[u]].luck)
                        {
                          pc[u].hp--;
                          snd.copy(splayhit);
                          pc[u].hit = 1;
                        }
                        if (pc[u].hp <= 0)
                          character[c[u]].dead = 0;
                        floor[pc[u].rd][pc[u].x + udx][pc[u].y + udy] = TILE + random(3) + 1;
                        pc[u].upd |= UDHP;
                      }
                      else if (floor[pc[u].rd][pc[u].x + udx][pc[u].y + udy] >= ITEM)
                      {
                        if ((a = additem(c[u], (floor[pc[u].rd][pc[u].x + udx][pc[u].y + udy] - ITEM))) != 0)
                        {
                          pc[u].itemfound = a;
                          floor[pc[u].rd][pc[u].x + udx][pc[u].y + udy] = TILE + random(3) + 1;
                          pc[u].upd = (pc[u].upd | UDWEIGHT | UDFOUND);
                          map[pc[u].roomx][pc[u].roomy].goodies--;
                          if (pc[u].itemfound == 57)
                          {
                            if (pc[u].hasmap == 0)
                            {
                              for (a = 0;a < 10;a++)
                              {
                                for (b = 0;b < 10;b++)
                                  pc[u].indmap[a][b] = themap[a][b];
                              }
                            }
                            pc[u].hasmap = 1;
                          }
                        }
                      }
                    }
                  }
                  else if (touse == 1 && character[c[u]].magic >= itemlist[touse].reqattr)
                  {
                    findfree(&projec, 1);
                    if (character[c[u]].inventory[pc[u].ring] == 37)
                      sc(projec[0], pc[u].x, pc[u].y, -1, itemlist[touse].level * character[c[u]].magic, 20, itemlist[touse].special, u+10, pc[u].rd, YELLOW, 176, 177, 178, 177);
                    else
                      sc(projec[0], pc[u].x, pc[u].y, pc[u].facing, itemlist[touse].level * character[c[u]].magic, 12, itemlist[touse].special, u+10, pc[u].rd, RED, 176, 177, 178, 177);
                    snd.copy(smagic);
                  }
                  else if (touse == 2 && ohand > 5)
                  {
                    findfree(&projec, 1);
                    sc(projec[0], pc[u].x, pc[u].y, pc[u].facing, itemlist[ohand].weight, 12, 0, u+10, pc[u].rd, DARKGRAY, 196, 92, 179, 47);
                    if (whand == RHAND)
                    {
                      if (removeitem(c[u], pc[u].lhand) == 0)
                        shift(u, pc[u].lhand);
                    }
                    else
                    {
                      if (removeitem(c[u], pc[u].rhand) == 0)
                        shift(u, pc[u].rhand);
                    }
                    pc[u].upd |= UDWEIGHT;
                    if (character[c[u]].inventory[ohand] == pc[u].wearing)
                      pc[u].wearing = 0;
                    use = 0;
                    snd.copy(sswish);
                  }
                  else if (touse == 3)
                  {
                    for (e = 0;e < 4;e++)
                    {
                      if (doors[pc[u].roomx + doorx[e]][pc[u].roomy * 2 + doory[e]] % 2 == SECRET && random(character[c[u]].intelligence + 30) - random(character[c[u]].luck / 2) <= character[c[u]].intelligence)
                      {
                        doors[pc[u].roomx + doorx[e]][pc[u].roomy * 2 + doory[e]] -= SECRET;
                        snd.copy(sfind);
                      }
                      gdoor(e+1, u);
                    }
                    pc[u].indmap[pc[u].roomx][pc[u].roomy] = 16;
                    maproom(pc[u].roomx, pc[u].roomy, &pc[u].indmap[pc[u].roomx][pc[u].roomy]);
                    if (pc[u].roomx != 9)
                      maproom(pc[u].roomx+1, pc[u].roomy, &pc[u].indmap[pc[u].roomx+1][pc[u].roomy]);
                    if (pc[u].roomx != 0)
                      maproom(pc[u].roomx-1, pc[u].roomy, &pc[u].indmap[pc[u].roomx-1][pc[u].roomy]);
                    if (pc[u].roomy != 9)
                      maproom(pc[u].roomx, pc[u].roomy+1, &pc[u].indmap[pc[u].roomx][pc[u].roomy+1]);
                    if (pc[u].roomy != 0)
                      maproom(pc[u].roomx, pc[u].roomy-1, &pc[u].indmap[pc[u].roomx][pc[u].roomy-1]);
                    for (a = 0;a < 10;a++)
                    {
                      for (b = 0;b < 10;b++)
                      {
                        if (floor[pc[u].rd][a][b] % 10 > TILE && floor[pc[u].rd][a][b]/10 != TILE && floor[pc[u].rd][a][b]/10 < CLEARH2O/10 && random(character[c[u]].intelligence + 30) - random(character[c[u]].luck / 2) <= character[c[u]].intelligence)
                        {
                          floor[pc[u].rd][a][b] -= floor[pc[u].rd][a][b] % 10;
                          snd.copy(sfind);
                        }
                      }
                    }
                  }
                  else if (itemlist[touse].pattern == 4 && random(150) <= character[c[u]].charisma + character[c[u]].luck / 2)
                  {
                    *cursed |= (char)itemlist[touse].special;
                    for (b = 0;b < 4;b++)
                      pc[b].upd |= UDCURSE;
                    snd.copy(scurse);
                  }
  }
  if (use == 1)
    pc[u].mp -= itemlist[touse].magic;
  pc[u].upd |= UDMP;
  if (whand == RHAND)
  {
    if (itemlist[character[c[u]].inventory[pc[u].rhand]].expend == 1 && use == 1)
    {
      if (removeitem(c[u], pc[u].rhand) == 0)
        shift(u, pc[u].rhand);
      pc[u].upd |= UDWEIGHT;
    }
  }
  else
  {
    if (itemlist[character[c[u]].inventory[pc[u].lhand]].expend == 1 && use == 1)
    {
      if (removeitem(c[u], pc[u].lhand) == 0)
        shift(u, pc[u].lhand);
      pc[u].upd |= UDWEIGHT;
    }
  }
  pc[u].upd |= UDHANDS;
  }
}

void findfree(int (*pro)[9], int howmany)
{
  int a, b, d, e;
  for (a = 0;a < 9;a++)
    (*pro)[a] = -1;
  for (a = 0;a < howmany;a++)
  {
    for (b = 0;b < 36;b++)
    {
      e = 0;
      for (d = 0;d < 9;d++)
        if ((*pro)[d] == b)
          e = 1;
      if (shots[b].lifespan <= 0 && e == 0)
        break;
    }
    (*pro)[a] = b;
  }
}

void sc(int p, int x, int y, int m, int l, int life, int s, int w, int r, int col, int f1, int f2, int f3, int f4)
{
  if (p == -1 || p >= 36)
    return;
  shots[p].x = x;
  shots[p].y = y;
  shots[p].moving = m;
  shots[p].level = l;
  shots[p].lifespan = life;
  shots[p].special = s;
  shots[p].who = w;
  shots[p].rd = r;
  shots[p].color = col;
  shots[p].frames[0] = f1;
  shots[p].frames[1] = f2;
  shots[p].frames[2] = f3;
  shots[p].frames[3] = f4;
}

void makegoody(int rd, int gx, int gy)
{
  int r = random(1000), i;

  if (gx < 0 || gx > 9)
    gx = random(10);
  if (gy < 0 || gy > 9)
    gy = random(10);
  i = 0;
  while (!(floor[rd][gx][gy] < 10 || floor[rd][gx][gy]/10 == CLEARH2O/10 || floor[rd][gx][gy]/10 == MUDDYH2O/10) && ++i < 200)
  {
    gx = random(10);
    gy = random(10);
  }
  if (i >= 200)
    return;
  i = random(54)+5;
  if (r < 900)
  {
    if (r < 350)
      i = MAGIC;
    else if (r < 360)
      i = ITEM + 57;
    else if (r < 650)
      i = MONEY;
    else if (r < 700)
      i = ITEM + 46;
    else if (r < 750)
      i = ITEM + 54;
    else if (r < 800)
      i = ITEM + 50;
    else if (r < 850)
      i = ITEM + 56;
    else if (r < 880)
      i = ITEM + 14;
    else if (r < 890)
      i = ITEM + 15;
    else if (r < 900)
      i = ITEM + 16;
    floor[rd][gx][gy] = i;
  }
  else if (r < 998)
  {
    while (!(itemlist[i].instock == 1 || itemlist[i].instock == 4))
      i = random(54)+5;
    floor[rd][gx][gy] = ITEM + i;
  }
  else
  {
    while (itemlist[i].instock != 2)
      i = random(54)+5;
    floor[rd][gx][gy] = ITEM + i;
  }
}

void createroom(int ch, int rx, int ry)
{
  int a, b, x, y;
  gdoor(MUP, ch);
  gdoor(MDOWN, ch);
  gdoor(MRIGHT, ch);
  gdoor(MLEFT, ch);
  if (map[rx][ry].traps > 25)
    map[rx][ry].traps = 25;
  if (map[rx][ry].goodies > 25)
    map[rx][ry].goodies = 25;
  if (map[rx][ry].fire > 25)
    map[rx][ry].fire = 25;
  if (map[rx][ry].walls > 25)
    map[rx][ry].walls = 25;
  for (a = 0;a < 10;a++)
  {
    for (b = 0;b < 10;b++)
      floor[pc[ch].rd][a][b] = TILE + random(3) + 1;
  }
  for (a = 0;a < 36;a++)
  {
    if (shots[a].rd == pc[ch].rd)
      shots[a].lifespan = 0;
  }
  for (a = 0;a < 10;a++)
  {
    mon[pc[ch].rd][a].hp = 0;
    mon[pc[ch].rd][a].cursed = NONE;
    mon[pc[ch].rd][a].hit = 0;
    mon[pc[ch].rd][a].target = -1;
  }
  for (a = 0;a < map[rx][ry].chests;a++)
  {
    do {
      x = random(10);
      y = random(10);
    } while (floor[pc[ch].rd][x][y] > 3);
    if (random(depth) == 0)
      floor[pc[ch].rd][x][y] = CHEST;
    else if (random(depth)%10 == 0)
      floor[pc[ch].rd][x][y] += TCHEST;
    else
      floor[pc[ch].rd][x][y] += CHEST;
  }
  for (a = 0;a < map[rx][ry].traps;a++)
  {
    do {
      x = random(10);
      y = random(10);
    } while (floor[pc[ch].rd][x][y] > 3);
    if (random(depth) == 0)
      floor[pc[ch].rd][x][y] = TRAP;
    else
      floor[pc[ch].rd][x][y] += TRAP;
  }
  for (a = 0;a < map[rx][ry].walls;a++)
  {
    do {
      x = random(10);
      y = random(10);
    } while (floor[pc[ch].rd][x][y] > 3);
    if (random(2) == 0)
      floor[pc[ch].rd][x][y] += SOLIDWALL;
    else
      floor[pc[ch].rd][x][y] += CRUMBWALL;
  }
  for (a = 0;a < map[rx][ry].fire;a++)
  {
    do {
      x = random(10);
      y = random(10);
    } while (floor[pc[ch].rd][x][y] > 3);
    floor[pc[ch].rd][x][y] = FIRE;
  }
  for (a = 0;a < map[rx][ry].monsters;a++)
  {
    do {
      x = random(10);
      y = random(10);
    } while (floor[pc[ch].rd][x][y] > 3);
    mon[pc[ch].rd][a].hp = map[rx][ry].monstertype->hpcap;
    mon[pc[ch].rd][a].x = x;
    mon[pc[ch].rd][a].y = y;
  }
  for (a = 0;a < map[rx][ry].goodies;a++)
    makegoody(pc[ch].rd, random(10), random(10));
  if (floor[pc[ch].rd][0][4] >= CHEST && floor[pc[ch].rd][0][4] < MONEY)
    floor[pc[ch].rd][0][4] = TILE + random(3) + 1;
  if (floor[pc[ch].rd][9][4] >= CHEST && floor[pc[ch].rd][9][4] < MONEY)
    floor[pc[ch].rd][9][4] = TILE + random(3) + 1;
  if (floor[pc[ch].rd][4][0] >= CHEST && floor[pc[ch].rd][4][0] < MONEY)
    floor[pc[ch].rd][4][0] = TILE + random(3) + 1;
  if (floor[pc[ch].rd][4][9] >= CHEST && floor[pc[ch].rd][4][9] < MONEY)
    floor[pc[ch].rd][4][9] = TILE + random(3) + 1;
  if (map[rx][ry].flooded == 1)
  {
    for (rx = 0;rx < 10;rx++)
    {
      for (ry = 0;ry < 10;ry++)
      {
        if (floor[pc[ch].rd][rx][ry]/10 == TILE/10)
          floor[pc[ch].rd][rx][ry] = CLEARH2O + random(4);
      }
    }
  }
  rooms[pc[ch].rd][X] = pc[ch].roomx;
  rooms[pc[ch].rd][Y] = pc[ch].roomy;
}

void namebar(void)
{
  int a, b;
  clrscr();
  gotoxy(1, 13);
  textattr(WHITE + (BLACK << 4));
  for (a = 1;a < 80;a++)
    putch(205);
  for (a = 0;a < 4;a++)
  {
  gotoxy(a*13+2, 13);
  if (c[a] != -1)
  {
    textattr(a+1 + (BLACK << 4));
    cprintf(" %d-%s", c[a], character[c[a]].playername);
  }
  }
  gotoxy(56, 13);
  textattr(YELLOW + (BLACK << 4));
  cprintf(" %s", dungeonname);
}

void update(int wx, int wy, int v)
{
  gotoxy(wx, wy);
  textattr(LIGHTGRAY + (BLACK << 4));
  cprintf("%d", v);
  while (wherex() < wx + 5)
    putch(SPACE);
}

void gdoor(int wall, int ch)
{
  int g, b;
  char f, dash;

  wall--;
  g = doors[pc[ch].roomx+doorx[wall]][pc[ch].roomy*2+doory[wall]];
  if (wall == MRIGHT - 1 || wall == MLEFT - 1)
  {
    dash = 179;
    if (g%2 == SECRET || g/10 != NOWALL || g == SOLID)
    {
      for (b = 0;b < 10;b++)
      {
        gwall[pc[ch].rd][wall][b][0] = DARKGRAY + (BLACK << 4);
        gwall[pc[ch].rd][wall][b][1] = walls[wall][b];
      }
    }
    if (g/10 == NOWALL && g%2 != SECRET && g != SOLID)
    {
      if (g%10 == OPEN)
        f = DARKGRAY + (LIGHTGRAY << 4);
      else
        f = YELLOW + (BROWN << 4);
      for (b = 0;b < 10;b++)
      {
        gwall[pc[ch].rd][wall][b][0] = f;
        gwall[pc[ch].rd][wall][b][1] = walls[wall][b];
      }
    }
  }
  else
  {
    dash = 196;
    if (g%2 == SECRET || g/10 != NOWALL || g == SOLID)
    {
      for (b = 0;b < 10;b++)
      {
        gwall[pc[ch].rd][wall][b][0] = DARKGRAY + (BLACK << 4);
        gwall[pc[ch].rd][wall][b][1] = walls[wall][b];
      }
    }
    if (g/10 == NOWALL && g%2 != SECRET && g != SOLID)
    {
      if (g%10 == OPEN)
        f = DARKGRAY + (LIGHTGRAY << 4);
      else
        f = YELLOW + (BROWN << 4);
      for (b = 0;b < 10;b++)
      {
        gwall[pc[ch].rd][wall][b][0] = f;
        gwall[pc[ch].rd][wall][b][1] = walls[wall][b];
      }
    }
  }
  if (g%2 != SECRET)
  {
    if (g%10 == OPEN && g != SOLID)
      gwall[pc[ch].rd][wall][4][0] = DARKGRAY + (LIGHTGRAY << 4);
    else if (g/10 == WOOD/10)
    {
      gwall[pc[ch].rd][wall][4][0] = BROWN + (LIGHTGRAY << 4);
      gwall[pc[ch].rd][wall][4][1] = dash;
    }
    else if (g/10 == STONE/10)
      gwall[pc[ch].rd][wall][4][0] = YELLOW + (BROWN << 4);
    else if (g/10 == GRATE/10)
    {
      gwall[pc[ch].rd][wall][4][0] = BLACK + (LIGHTGRAY << 4);
      gwall[pc[ch].rd][wall][4][1] = '#';
    }
    else if (g/10 == STEEL/10)
    {
      gwall[pc[ch].rd][wall][4][0] = DARKGRAY + (LIGHTGRAY << 4);
      gwall[pc[ch].rd][wall][4][1] = dash;
    }
    if (g%10 > HARD)
     gwall[pc[ch].rd][wall][4][1] = 140;
  }
}

void sc2(int ch)
{
  static int fm;
  int star[4] = {92, 47, 92, 47}, x = wherex(), y = wherey();
  char smstr[2];
  type t;
  t.tset(5);
  smstr[1] = 0;
  smstr[0] = star[fm++];
  if (fm == 4)
    fm = 0;
  t.tw(smstr);
  gotoxy(x, y);
  putch(ch);
}

void soundtest(void)
{
  char lables[15][19] = {{"get a curse"},{"cure a curse"},{"sword swish"},
       {"search"},{"it's magic"},{"monster hit"}, {"player hit"},
       {"healing"}, {"arctic wind"}, {"explosion"}, {"lightning"},
       {"got a light?"}, {"somebody died"}, {"dropped something"},
       {"spilled chest"}};
  int a = 0, b = 1, c = 2, d = 0;
  int sb[10];
  clrscr();
  for (a = 0;a < 15;a++)
  {
    gotoxy(2, a+1);
    cputs(lables[a]);
  }
  a = 0;
  while (a == 0)
  {
    if (b < 1)
      b = 15;
    else if (b > 15)
      b = 1;
    if (c != b)
    {
      gotoxy(1, c);
      putch(32);
      gotoxy(1, b);
      putch('>');
      c = b;
    }
    switch(getkey())
    {
      case UP: b--; break;
      case DOWN: b++; break;
      case SPACE: switch(b)
                  {
                    case 1: snd.copy(scurse); break;
                    case 2: snd.copy(scure); break;
                    case 3: snd.copy(sswish); break;
                    case 4: snd.copy(sfind); break;
                    case 5: snd.copy(smagic); break;
                    case 6: snd.copy(smonhit); break;
                    case 7: snd.copy(splayhit); break;
                    case 8: snd.copy(sheal); break;
                    case 9: snd.copy(swind); break;
                    case 10: snd.copy(sboom); break;
                    case 11: snd.copy(sbolt); break;
                    case 12: snd.copy(slight); break;
                    case 13: snd.copy(sdead); break;
                    case 14: snd.copy(sdrop); break;
                    case 15: for (d = 0;d < 10;d++)
                               sb[d] = random(5000) + 2000;
                             snd.copy(sb); break;

                  }
                  for (d = 0;d < 10;d++)
                  {
                    snd.play();
                    delay(35);
                    snd.pstop();
                    delay(75);
                  }
                  snd.pstop(1);
                  break;
      case ESCAPE: a = 1;
    }
  }
}

int main(void)
{
  int inpt, menu = 1, a;
  unsigned char inword[41];
  type t;
  randomize();
  _setcursortype(_NOCURSOR);
  textattr(LIGHTGRAY + (BLACK << 4));
  clrscr();
  doorx[MUP-1] = 0;
  doory[MUP-1] = 0;
  doorx[MDOWN-1] = 0;
  doory[MDOWN-1] = 2;
  doorx[MRIGHT-1] = 1;
  doory[MRIGHT-1] = 1;
  doorx[MLEFT-1] = 0;
  doory[MLEFT-1] = 1;
  createitems();
  if (loadgame() == 1)
  {
    cputs("Character data file missing or unuseable.\r\n");
    cputs("(c)reate new or (e)xit program? ");
    if (getche() == (int)'c')
    {
      for (inpt = 0;inpt < 8;inpt++)
	character[inpt].dead = 0;

      gamespeed = 1;

      playkeys[0].up = (int)'r';
      playkeys[0].down = (int)'c';
      playkeys[0].right = (int)'f';
      playkeys[0].left = (int)'d';
      playkeys[0].rhand = (int)'w';
      playkeys[0].lhand = (int)'q';
      playkeys[0].menu = (int)'e';
      playkeys[0].drop = (int)'s';

      playkeys[1].up = (int)'o';
      playkeys[1].down = (int)',';
      playkeys[1].right = (int)'l';
      playkeys[1].left = (int)'k';
      playkeys[1].rhand = (int)'b';
      playkeys[1].lhand = (int)'v';
      playkeys[1].menu = (int)'n';
      playkeys[1].drop = (int)'j';

      playkeys[2].up = UP;
      playkeys[2].down = DOWN;
      playkeys[2].right = RIGHT;
      playkeys[2].left = LEFT;
      playkeys[2].rhand = (int)'[';
      playkeys[2].lhand = (int)'p';
      playkeys[2].menu = (int)']';
      playkeys[2].drop = (int)'\'';

      playkeys[3].up = (int)'8';
      playkeys[3].down = (int)'2';
      playkeys[3].right = (int)'6';
      playkeys[3].left = (int)'4';
      playkeys[3].rhand = (int)'0';
      playkeys[3].lhand = (int)'1';
      playkeys[3].menu = (int)'7';
      playkeys[3].drop = (int)'9';

      if (savegame() == 1)
      {
	cputs("Unable to create new file.\r\n");
        _setcursortype(_NORMALCURSOR);
	return 0;
      }
    }
    else
    {
      _setcursortype(_NORMALCURSOR);
      return 0;
    }
  }
  drawlogo();
  textattr(LIGHTGRAY + (BLACK << 4));
  clrscr();
  t.tset(5);
  gotoxy(1,1);
  for (inpt = 0;inpt < 79;inpt++)
    sc2(196);
  sc2(191);
  for (inpt = 0;inpt < 22;inpt++)
  {
    gotoxy(80, inpt + 2);
    sc2(179);
  }
  gotoxy(80, 24);
  sc2(217);
  for (inpt = 0;inpt < 78;inpt++)
  {
    gotoxy(79-inpt, 24);
    sc2(196);
  }
  gotoxy(1, 24);
  sc2(192);
  for (inpt = 0;inpt < 22;inpt++)
  {
    gotoxy(1, 23-inpt);
    sc2(179);
  }
  gotoxy(1,1);
  sc2(218);
  t.tset(25);
  gotoxy(38, 2);
  t.tw("Beta");
  gotoxy(32, 4);
  t.tw("\"The Dungeon Game.\"");
  gotoxy(27, 6);
  t.tw("This product is shareware.");
  gotoxy(25, 8);
  t.tw("If you like it, please send $5 to:");
  gotoxy(32, 10);
  t.tw("CGD");
  gotoxy(32, 11);
  t.tw("807 E. Wilson St.");
  gotoxy(32, 12);
  t.tw("Batavia, IL  60510");
  getkey();
  if (stricmp(password, "") != 0)
  {
    t.tset(25, 1);
    gotoxy(36, 19);
    t.tw("Password");
    t.tset(5, 1);
    gotoxy(19, 20);
    for (inpt = 0;inpt < 41;inpt++)
      sc2(196);
    sc2(191);
    gotoxy(60, 21);
    sc2(179);
    gotoxy(60, 22);
    sc2(217);
    for (inpt = 0;inpt < 40;inpt++)
    {
      gotoxy(59-inpt, 22);
      sc2(196);
    }
    gotoxy(19, 22);
    sc2(192);
    gotoxy(19, 21);
    sc2(179);
    gotoxy(19, 20);
    sc2(218);
    t.tset(25, 1);
    getkey();
    gotoxy(20, 21);
    getstr(&inword, 40, 1);
    while (stricmp(inword, password) != 0 && stricmp(inword, "i aM a fINE yOUNG vIKING bOY") != 0)
    {
      if (stricmp(inword, "quit") == 0)
      {
        _setcursortype(_NORMALCURSOR);
        return 0;
      }
      if (stricmp(inword, "i wANNA cHEAT") == 0)
        cheat = 1;
      if (stricmp(inword, "sOUND tEST") == 0)
        soundtest();
      gotoxy(20, 21);
      t.tw("Sorry, wrong password.");
      gotoxy(20, 21);
      t.tw("type \"quit\" to exit, lowercase counts.");
      gotoxy(20, 21);
      t.tw("                                        ");
      getkey();
      gotoxy(20, 21);
      cputs("                                        ");
      gotoxy(20, 21);
      getstr(&inword, 40, 1);
    }
  }
  gotoxy(20, 21);
  t.tw("Press any key to continue.              ");
  getch();
  clrscr();
  if (quicksaved == 1)
  {
    players = 0;
    for (inpt = 0;inpt < 8;inpt++)
    {
      if (character[inpt].dead == 1 && character[inpt].playing == 1)
        players++;
    }
    playgame();
    textattr(LIGHTGRAY + (BLACK << 4));
    clrscr();
    menu = 2;
  }
  characters = 0;
  for (a = 0;a < 8;a++)
    if (character[a].dead == 1)
      characters++;
  do {
  if (quicksaved == 0)
  {
  if (menu == 1)
  {
  cprintf("\r\nmain menu\r\n");
  cputs("1. game menu.\r\n");
  cputs("2. save all.\r\n");
  cputs("3. load all.\r\n");
  cputs("4. save one character.\r\n");
  cputs("5. load one character.\r\n");
  cputs("6. password.\r\n");
  cputs("7. define keys.\r\n");
  cputs("8. quit.\r\n");
  if (quicksaved == 0)
  {
  switch(getch())
  {
    case (int)'1': menu = 2; break;
    case (int)'2': if (savegame() == 1)
		     cputs("Unable to save data.\r\n");
                   break;
    case (int)'3': if (loadgame() == 1)
                     cputs("Unable to load data.\r\n");
                   break;
    case (int)'4': saveonechar(); break;
    case (int)'5': loadonechar(); break;
    case (int)'6': getpass(); break;
    case (int)'7': definekeys(); break;
    case (int)'8': cprintf("\r\nSave? y/n");
                   if (getch() == (int)'y')
                   {
                   if (savegame() == 1)
		   {
		     cputs("Unable to save data.\r\n");
		     cputs("(e)xit without saving, or (r)eturn to program? ");
		     if (getche() == (int)'e')
		       menu = 0;
		   }
		   else
		     menu = 0;
                   }
                   else
                     menu = 0;
  }
  }
  }
  else if (menu == 2)
  {
  characters = 0;
  for (a = 0;a < 8;a++)
  {
    if (character[a].dead == 1)
    {
      cprintf("\r\nPlayer %d -- %s.", a, character[a].playername);
      characters++;
    }
    else
      cprintf("\r\nPlayer %d -- XXXX DEAD XXXX", a);
  }
  cprintf("\r\ngame menu(%d characters)\r\n", characters);
  cputs("1. add character.\r\n");
  cputs("2. modify character.\r\n");
  cputs("3. view character.\r\n");
  cputs("4. kill character.\r\n");
  cputs("5. buy items.\r\n");
  cputs("6. sell items.\r\n");
  cputs("7. begin.\r\n");
  cputs("8. main menu.\r\n");
  if (quicksaved == 0)
  {
  switch(getch())
  {
    case (int)'1': addplayer(); break;
    case (int)'2': modplayer(); break;
    case (int)'3': viewplayer(); break;
    case (int)'4': cputs("Kill which player?");
		   inpt = getch();
		   inpt -= 48;
		   if (inpt >= 0 && inpt <= 7 && character[inpt].dead == 1)
                   {

                     cprintf("\r\nKill %s, are you sure?(y/n)", character[inpt].playername);
                     if (getch() == 'y')
		       character[inpt].dead = 0;
                   }
		   break;
    case (int)'5': buyitems(); break;
    case (int)'6': sellitems(); break;
    case (int)'7': playgame();
                   textattr(LIGHTGRAY + (BLACK << 4));
                   clrscr();
                   menu = 2;
                   break;
    case (int)'8': menu = 1; break;
  }
  }
  }
  }
  else
  {
    if (savegame() == 1)
    {
      cputs("Unable to save character data.\r\n");
      getch();
      quicksaved = 0;
    }
    else
      menu = 0;
  }
  } while (menu != 0);
  _setcursortype(_NORMALCURSOR);
  return 0;
}
