#include "dg4p.h"

extern char dungeonname[30];
extern int gamespeed, doors[11][21], floor[4][10][10], depth, c[4], rdu[4], players;
extern int doorx[4], doory[4], startx, starty, mysticx, mysticy, rooms[4][2];
extern int dcopy[11][21];
extern char walls[4][10], gwall[4][4][10][2];
extern char bits[8];
extern char controls[6][9];
extern char classes[12][12];
extern sndsys snd;
extern int sb[10];
extern int ssilence[10];
extern int sblank[10];
extern int scurse[10];
extern int scure[10];
extern int sswish[10];
extern int sfind[10];
extern int smagic[10];
extern int smonhit[10];
extern int splayhit[10];
extern int sheal[10];
extern int swind[10];
extern int sboom[10];
extern int sbolt[10];
extern int slight[10];
extern int sdead[10];
extern int sdrop[10];

extern char gmap[16];
extern char themap[10][10], password[41];
extern int quicksaved, characters;

item itemlist[60];
player character[8];
ingameplay pc[4];
monster monsters[6];
ingamemon mon[4][10];
room map[10][10];
projectile shots[36];
keys playkeys[4];

void stickkey(int (*keybuf)[10], int ch)
{
  for (int a = 0;a < 10;a++)
  {
    if ((*keybuf)[a] == 0)
    {
      (*keybuf)[a] = ch;
      break;
    }
  }
  if (a == 10)
  {
    pullkey(keybuf);
    (*keybuf)[9] = ch;
  }
}

int pullkey(int (*keybuf)[10])
{
  int b = (*keybuf)[0];
  for (int a = 0;a < 9;a++)
    (*keybuf)[a] = (*keybuf)[a+1];
  (*keybuf)[9] = 0;
  return b;
}

void defplayer(int pl)
{
  int x, y;
  switch (pl)
  {
    case 0: x = 5;
            y = 4;
            break;
    case 1: x = 4;
            y = 3;
            break;
    case 2: x = 4;
            y = 5;
            break;
    case 3: x = 3;
            y = 5;
            break;
  }
  pc[pl].upd = NONE;
  pc[pl].x = x;
  pc[pl].y = y;
  pc[pl].facing = MRIGHT;
  pc[pl].moving = NONE;
  pc[pl].roomx = startx;
  pc[pl].roomy = starty;
  pc[pl].inmenu = -1;
  pc[pl].casting = 0;
  pc[pl].hit = 0;
  pc[pl].foe = 0;
  pc[pl].newright = 0;
  pc[pl].newleft = 1;
  pc[pl].newwear = 0;
  pc[pl].itemfound = 0;
  pc[pl].dropping = 0;
  pc[pl].fx = x;
  pc[pl].fy = y;
  pc[pl].control = STAND;
  pc[pl].view = NONE;
  pc[pl].rhand = 0;
  pc[pl].lhand = 1;
  pc[pl].wearing = 0;
  pc[pl].inaction = 0;
  pc[pl].hp = character[c[pl]].hpcap;
  pc[pl].mp = character[c[pl]].mpcap;
  pc[pl].rd = -1;
  for (x = 0;x < 4;x++)
  {
    if (pc[x].roomx == startx && pc[x].roomy == starty && x != pl && c[x] != -1)
    {
      pc[pl].rd = pc[x].rd;
      rdu[pc[x].rd]++;
      break;
    }
  }
  if (pc[pl].rd == -1)
  {
    for (x = 0;x < 4;x++)
    {
      if (rdu[x] == 0)
      {
        pc[pl].rd = x;
        rdu[x] = 1;
        createroom(pl, startx, starty);
        break;
      }
    }
  }
  pc[pl].lanlit = UNLIT;
  pc[pl].torchlit = UNLIT;
  pc[pl].ring = 0;
  pc[pl].newring = 0;
  pc[pl].hasmap = 0;
  character[c[pl]].playing = 1;
}

void sellstuff(int a)
{
  int b, d;
      for (b = 6;b < 60;b++)
      {
        if (character[c[a]].inventory[b] == 57)
          break;
      }
      if (b < 60)
      {
        d = character[c[a]].number[b];
        while (d-- > 0)
        {
          character[c[a]].money += itemlist[57].cost;
          removeitem(c[a], b);
        }
        shift(a, b);
      }
}
void chmenu(int ch, int sndst)
{
  int cx = 10, ox = 0, a = 0, b, e;
  gotoxy(40, 10);
  cprintf("%s", controls[pc[ch].control-1]);
  gotoxy(35, 12);
  cputs("                  ");
  gotoxy(40, 11);
  cprintf("%c", pc[ch].view+48);
  do {
    if (cx < 10)
      cx = 15;
    else if (cx > 15)
      cx = 10;
    if (cx != ox)
    {
      gotoxy(28, ox);
      putch(32);
      gotoxy(28, cx);
      putch('>');
      ox = cx;
    }
    switch(getkey())
    {
      case UP: cx--; break;
      case DOWN: cx++; break;
      case SPACE: switch (cx)
                  {
                    case 10: b = 0;
                            do {
                              switch (getkey())
                              {
                                case LEFT: pc[ch].control--;
                                           if ((pc[ch].control < PLAYER1 && pc[ch].view != NONE) || (pc[ch].control < STAND && pc[ch].view == NONE))
                                             pc[ch].control = FOLLOW4;
                                           break;
                                case RIGHT: pc[ch].control++;
                                            if (pc[ch].control > FOLLOW4)
                                            {
                                              if (pc[ch].view != NONE)
                                                pc[ch].control = PLAYER1;
                                              else
                                                pc[ch].control = STAND;
                                            }
                                            break;
                                case SPACE: b = 1; break;
                              }
                              gotoxy(40, 10);
                              cprintf("%s", controls[pc[ch].control-1]);
                            } while (b == 0);
                            break;
                    case 11: b = 0;
                            do {
                              switch (getkey())
                              {
                                case LEFT: pc[ch].view--;
                                           if (pc[ch].view < NONE)
                                             pc[ch].view = PLAYER4;
                                           break;
                                case RIGHT: pc[ch].view++;
                                            if (pc[ch].view > PLAYER4)
                                              pc[ch].view = NONE;
                                            break;
                                case SPACE: b = 1; break;
                              }
                              gotoxy(40, 11);
                              cprintf("%c", pc[ch].view+48);
                            } while (b == 0);
                            break;
                    case 12: if (c[ch] != -1)
                             {
                               gotoxy(35, 12);
                               cputs("Slot taken");
                               break;
                             }
                             do {
                               gotoxy(35, 12);
                               cputs("          ");
                               gotoxy(35, 12);
                               cputs("Who? ");
                               cin >> c[ch];
                               cin.clear();
                               for (b = 0;b < 4;b++)
                                 if (c[ch] == c[b] && ch != b)
                                   c[ch] = -1;
                             } while (c[ch] == -1);
                             defplayer(ch);
                             pc[ch].control = STAND;
                             players++;
                             gotoxy(40, 10);
                             cprintf("%s", controls[pc[ch].control-1]);
                             gotoxy(35, 12);
                             cputs("                  ");
                             gotoxy(40, 11);
                             cprintf("%c", pc[ch].view+48);
                             if (character[c[ch]].items == 6)
                             {
                               gotoxy(1, 20);
                               cputs("\"You wouldn't dare go down empty-handed, Would you?\"\r\n");
                               cputs("\"Here, please take a tinder box and torch.\"");
                               character[c[ch]].inventory[6] = 48;
                               character[c[ch]].number[6] = 1;
                               character[c[ch]].inventory[7] = 50;
                               character[c[ch]].number[7] = 1;
                               character[c[ch]].items = 8;
                               character[c[ch]].weight = 4;
                             }
                             break;
                    case 13: gotoxy(40, 13);
                             cputs("Are you sure?(y/n) ");
                             if (getch() == 'y')
                             {
                               character[c[ch]].playing = 0;
                               players--;
                               killplayer(ch);
                             }
                             break;
                    case 14: viewplayer(c[ch]);
                             pausescr(sndst);
                             ox = 13;
                             break;
                    case 15: gotoxy(28, cx);
                             putch(SPACE);
                             a = 1;
                             break;
                  }
                  break;
    }
  } while (a == 0);
}

void killplayer(int ch)
{
  int a, b;
  snd.copy(sdead);
  for (a = 0;a < 10;a++)
  {
    snd.play();
    delay(35);
    snd.pstop();
    delay(75);
  }
  snd.pstop(1);
  textattr(LIGHTGRAY + (BLACK << 4));
  gotoxy(20, 20);
  cprintf("Character #%d, %s, has died!               ", c[ch], character[c[ch]].playername);
  gotoxy(20, 21);
  cprintf("You may choose to save the character, but you");
  gotoxy(20, 22);
  cprintf("wlll lose all money and experience earned so far.");
  gotoxy(20, 23);
  cprintf("(K)ill them forever, or (S)ave");
  while (getkey() != 0)
    ;
  for (;;)
  {
    a = getch();
    if (a == 'k')
    {
      character[c[ch]].dead = 0;
      break;
    }
    else if (a == 's')
    {
      snd.copy(sfind, &sb);
      snd.copy(sb);
      for (b = 0;b < 10;b++)
      {
        snd.play();
        delay(35);
        snd.pstop();
        delay(75);
      }
      snd.pstop(1);
      character[c[ch]].dead = 1;
      character[c[ch]].experience = 0;
      character[c[ch]].money = 0;
      break;
    }
  }
  c[ch] = -1;
}

int attacknear(int ch)
{
  int a, b, d = NONE;
  b = itemlist[character[c[ch]].inventory[pc[ch].rhand]].pattern;
  for (a = 0;a < 10;a++)
  {
    if (mon[pc[ch].rd][a].hp > 0)
    {
    if (pc[ch].x == mon[pc[ch].rd][a].x && ((pc[ch].y - 1 == mon[pc[ch].rd][a].y && b == 1) || (mon[pc[ch].rd][a].y < pc[ch].y && (b == 2 || b == 3))))
    {
      d = MUP;
      if (pc[ch].facing == d)
        d = RHAND;
    }
    if (pc[ch].x == mon[pc[ch].rd][a].x && ((pc[ch].y + 1 == mon[pc[ch].rd][a].y && b == 1) || (mon[pc[ch].rd][a].y > pc[ch].y && (b == 2 || b == 3))))
    {
      d = MDOWN;
      if (pc[ch].facing == d)
        d = RHAND;
    }
    if (pc[ch].y == mon[pc[ch].rd][a].y && ((pc[ch].x - 1 == mon[pc[ch].rd][a].x && b == 1) || (mon[pc[ch].rd][a].x < pc[ch].x && (b == 2 || b == 3))))
    {
      d = MLEFT;
      if (pc[ch].facing == d)
        d = RHAND;
    }
    if (pc[ch].y == mon[pc[ch].rd][a].y && ((pc[ch].x + 1 == mon[pc[ch].rd][a].x && b == 1) || (mon[pc[ch].rd][a].x > pc[ch].x && (b == 2 || b == 3))))
    {
      d = MRIGHT;
      if (pc[ch].facing == d)
        d = RHAND;
    }
    if (d != NONE)
      break;
    }
  }
  return d;
}

int seek(int ch, int tx, int ty)
{
  int a, b = NONE, dx = 0, dy = 0;
  a = random(4);
  if (a == 0)
  {
    if (tx - pc[ch].x < 0)
      b = MLEFT;
    else if (tx - pc[ch].x > 0)
      b = MRIGHT;
  }
  else if (a == 1)
  {
    if (ty - pc[ch].y < 0)
      b = MUP;
    else if (ty - pc[ch].y > 0)
      b = MDOWN;
  }
  else
    b = pc[ch].facing;
  switch (b)
  {
    case MUP: dy = -1; break;
    case MDOWN: dy = 1; break;
    case MRIGHT: dx = 1; break;
    case MLEFT: dx = -1; break;
  }
  a = floor[pc[ch].rd][pc[ch].x + dx][pc[ch].y + dy];
  if (a == TRAP || a == TCHEST || a == FIRE || a == SOLIDWALL/10 || 1 == CRUMBWALL/10)
    b = NONE;
  return b;
}

int task(int ch)
{
  int a, b, d = NONE, gx = 0, gy = 0;
  a = character[c[ch]].inventory[pc[ch].rhand];
  if (a == 3 || a == 42)
  {
    if (pc[ch].x == 4 && pc[ch].y == 0)
      d = MUP;
    else if (pc[ch].x == 4 && pc[ch].y == 9)
      d = MDOWN;
    else if (pc[ch].x == 0 && pc[ch].y == 4)
      d = MLEFT;
    else if (pc[ch].x == 9 && pc[ch].y == 4)
      d = MRIGHT;
    if (d != NONE)
    {
      b = doors[pc[ch].roomx + doorx[d-1]][pc[ch].roomy * 2 + doory[d-1]];
      if (b % 2 == 1 || b % 10 == OPEN)
        d = RHAND;
    }
    else
      d = RHAND;
  }
  else if (a == 0 && map[pc[ch].roomx][pc[ch].roomy].monsters == 0)
  {
    b = 0;
    for (gx = 0;gx < 10;gx++)
    {
      for (gy = 0;gy < 10;gy ++)
      {
        if (floor[pc[ch].rd][gx][gy] == CHEST || (floor[pc[ch].rd][gx][gy] % 10  == TCHEST && floor[pc[ch].rd][gx][gy] != TCHEST))
        {
          b = 1;
          break;
        }
      }
      if (b == 1)
        break;
    }
    if (gx < 10 && gy < 10)
      d = seek(ch, gx, gy);
    else
    {
      b = 0;
      for (gx = 0;gx < 10;gx++)
      {
        for (gy = 0;gy < 10;gy ++)
        {
          if (floor[pc[ch].rd][gx][gy] >= MONEY)
          {
            b = 1;
            break;
          }
        }
        if (b == 1)
          break;
      }
      if (gx < 10 && gy < 10)
      {
        if (pc[ch].x - gx == 1 && pc[ch].y == gy)
        {
          if (pc[ch].facing == MLEFT)
            d = RHAND;
          else
            d = MLEFT;
        }
        if (pc[ch].x - gx == -1 && pc[ch].y == gy)
        {
          if (pc[ch].facing == MRIGHT)
            d = RHAND;
          else
            d = MRIGHT;
        }
        if (pc[ch].x == gx && pc[ch].y - gy == 1)
        {
          if (pc[ch].facing == MUP)
            d = RHAND;
          else
            d = MUP;
        }
        if (pc[ch].x == gx && pc[ch].y - gy == -1)
        {
          if (pc[ch].facing == MDOWN)
            d = RHAND;
          else
            d = MDOWN;
        }
        if (d == NONE)
          d = seek(ch, gx, gy);
      }
    }
  }
  else if (itemlist[a].pattern == 1 || itemlist[a].pattern == 2 || itemlist[a].pattern == 3)
  {
    d = attacknear(ch);
    if (d == NONE)
    {
      for (b = 0;b < 10;b++)
      {
        if (mon[pc[ch].rd][b].hp > 0)
        {
          d = seek(ch, mon[pc[ch].rd][b].x, mon[pc[ch].rd][b].y);
          break;
        }
      }
    }
  }
  return d;
}

int follow(int ch)
{
  int a, b, d = NONE;
  d = attacknear(ch);
  if (d == NONE)
  {
    (pc[ch].control == FOLLOW1) ? (b = PLAYER1) : (b = PLAYER2);
    switch (pc[ch].control)
    {
      case FOLLOW1: b = PLAYER1; break;
      case FOLLOW2: b = PLAYER2; break;
      case FOLLOW3: b = PLAYER3; break;
      case FOLLOW4: b = PLAYER4; break;
    }
    for (a = 0;a < 4;a++)
    {
      if (pc[a].control == b)
        break;
    }
    if (pc[ch].roomx == pc[a].roomx && pc[ch].roomy == pc[a].roomy)
      d = seek(ch, pc[a].x, pc[a].y);
    else
    {
      if (pc[ch].roomx == pc[a].roomx)
      {
        if (pc[ch].roomy - pc[a].roomy == 1)
          d = seek(ch, 4, -1);
        else if (pc[ch].roomy - pc[a].roomy == -1)
          d = seek(ch, 4, 10);
      }
      if (pc[ch].roomy == pc[a].roomy)
      {
        if (pc[ch].roomx - pc[a].roomx == 1)
          d = seek(ch, -1, 4);
        else if (pc[ch].roomx - pc[a].roomx == -1)
          d = seek(ch, 10, 4);
      }
    }
  }
  return d;
}

void pausescr(int sndst)
{
  char on_off[2][4] = {{"Off"}, {"On "}};
                   clrscr();
                   gotoxy(30, 1);
                   cputs("Continue");
                   gotoxy(30, 2);
                   cputs("Quit");
                   gotoxy(30, 3);
                   cputs("Speed:");
                   gotoxy(30, 4);
                   cprintf("Sound: %s", on_off[sndst]);
                   gotoxy(29, 9);
                   cputs("----------------");
                   gotoxy(30, 10);
                   cputs("Control:");
                   gotoxy(30, 11);
                   cputs("Window:");
                   gotoxy(30, 12);
                   cputs("Add");
                   gotoxy(30, 13);
                   cputs("Remove");
                   gotoxy(30, 14);
                   cputs("View");
                   gotoxy(30, 15);
                   cputs("Done");
}

void maproom(int mx, int my, char *theroom)
{
  int a;
  if (*theroom < 16)
    *theroom = 0;
  else
    *theroom = 16;
  a = doors[mx + doorx[MUP-1]][my * 2 + doory[MUP-1]];
  if (a != SOLID && a % 2 != SECRET)
    *theroom += 1;
  a = doors[mx + doorx[MRIGHT-1]][my * 2 + doory[MRIGHT-1]];
  if (a != SOLID && a % 2 != SECRET)
    *theroom += 2;
  a = doors[mx + doorx[MDOWN-1]][my * 2 + doory[MDOWN-1]];
  if (a != SOLID && a % 2 != SECRET)
    *theroom += 4;
  a = doors[mx + doorx[MLEFT-1]][my * 2 + doory[MLEFT-1]];
  if (a != SOLID && a % 2 != SECRET)
    *theroom += 8;
}

void playgame(void)
{
  int a, b, d, e, g, pkey[4], soundstat = 1;
  int frame = 0, cx, ox, dx, dy, projec[9], fire[5] = {RED, LIGHTRED, YELLOW, BROWN, WHITE};
  int water[4][4] = {{176, 177, 178, 177},{177, 178, 177, 176},{178, 177, 176, 177},{177, 176, 177, 178}};
  char scrbuf[24][12], f, light[2][4][2] = {
  {{WHITE + (LIGHTGRAY << 4), 177}, {WHITE + (LIGHTGRAY << 4), 176}, {WHITE + (LIGHTGRAY << 4), 176}, {WHITE + (BROWN << 4), 176}},
  {{WHITE + (LIGHTGRAY << 4), 178}, {WHITE + (LIGHTGRAY << 4), 177}, {WHITE + (LIGHTGRAY << 4), 177}, {WHITE + (BROWN << 4), 177}}};
  int warp[4] = {21, 128, 21, 235};
  char on_off[2][4] = {{"Off"}, {"On "}};
  monster *mt;
  int *attr;
  int kbuf[4][10];
  char far *screen = (char far *)MK_FP(0xb800,0);
  int pwin[4][2] = {{0,0},{0,80},{13,0},{13,80}};
  int mvalue[16] = {5,10,50,100,500,1000,1500,2000,3000,4000,5000,6000,8000,
                   10000,20000,31000};
  char mcolor[16] = {RED, LIGHTRED, MAGENTA, LIGHTMAGENTA, BROWN, YELLOW, GREEN,
                    LIGHTGREEN, CYAN, LIGHTCYAN, BLUE, LIGHTBLUE, BLACK,
                    DARKGRAY, LIGHTGRAY, WHITE};
  _setcursortype(_NOCURSOR);
  characters = 0;
  for (a = 0;a < 8;a++)
  {
    if (character[a].dead == 1)
      characters++;
  }
  if (characters <= 0)
  {
    cputs("No characters.\r\n");
    _setcursortype(_NORMALCURSOR);
    return;
  }
  for (a = 0;a < 10;a++)
  {
    kbuf[0][a] = 0;
    kbuf[1][a] = 0;
    kbuf[2][a] = 0;
    kbuf[3][a] = 0;
  }
  snd.sndon_off();
  snd.copy(ssilence);
  if (quicksaved == 0)
  {
  for (a = 0;a < 4;a++)
  {
    for (b = 0;b < 10;b++)
      walls[a][b] = (char)random(3)+176;
  }
  for (a = 0;a < 8;a++)
    character[a].playing = 0;
  for (a = 0;a < 4;a++)
  {
    c[a] = -1;
    rdu[a] = 0;
    for (b = 0;b < 10;b++)
      mon[a][b].hp = 0;
  }
  for (a = 0;a < 36;a++)
    shots[a].lifespan = 0;
  cputs("There is and old man operating the eleveator.  He asks you:\r\n");
  do {
    cputs("\"How deep will you go?\"");
    cin >> depth;
    cin.clear();
  } while (depth <= 0 || depth > 100);
  do {
    cputs("\"Who will go down first?\"");
    cin >> c[0];
    if (c[0] == 9)
      _setcursortype(_NORMALCURSOR);
      return;
    cin.clear();
  } while (character[c[0]].dead == 0 || c[0] < 0 || c[0] > 7);
  if (character[c[0]].items == 6)
  {
    cputs("\"You wouldn't dare go down empty-handed, Would you?\"\r\n");
    cputs("\"Here, please take a tinder box and torch.\"");
    character[c[0]].inventory[6] = 48;
    character[c[0]].number[6] = 1;
    character[c[0]].inventory[7] = 50;
    character[c[0]].number[7] = 1;
    character[c[0]].items = 8;
    character[c[0]].weight = 4;
    getch();
  }
  createdungeon();
  for (dx = 0;dx < 10;dx++)
  {
    for (dy = 0;dy < 10;dy++)
    {
      themap[dx][dy] = 0;
      maproom(dx, dy, &themap[dx][dy]);
      for (a = 0;a < 4;a++)
        pc[a].indmap[dx][dy] = themap[dx][dy];
    }
  }
  players = 1;
  defplayer(0);
  pc[0].control = PLAYER1;
  pc[0].view = PLAYER1;
  }
  else
  {
    quicksaved = 0;
    if (quickload() != 0)
    {
      perror("unable to load game");
      getkey();
      _setcursortype(_NORMALCURSOR);
      return;
    }
    for (a = 0;a < 4;a++)
      pc[a].inmenu = -1;
  }

  namebar();

  while (depth != 0)
  {
    if (players == 0)
      depth = 0;
    if (++frame == 4)
    {
      frame = 0;
      if (random(30-depth) == 0)
      {
        dx = random(10);
        dy = random(10);
        if (!(dx == startx && dy == starty) && map[dx][dy].traps < 80)
          map[dx][dy].traps++;
      }
    }
    else if (frame == 3)
    {
      d = -1;
      dx = random(10);
      dy = random(10);
      for (a = 0;a < 4;a++)
      {
      if (c[a] != -1 && character[c[a]].playing == 1 && character[c[a]].dead == 1)
      {
        if (dx == pc[a].roomx && dy == pc[a].roomy)
          d = pc[a].rd;
        else if (character[c[a]].inventory[pc[a].ring] == 55)
        {
          d = pc[a].rd;
          dx = pc[a].roomx;
          dy = pc[a].roomy;
        }
        if (pc[a].lanlit == LIT)
        {
          if (character[c[a]].inventory[pc[a].rhand] != 47 && character[c[a]].inventory[pc[a].lhand] != 47)
            pc[a].lanlit = UNLIT;
          else
          {
            if ((character[c[a]].oillight -= 1) <= 0)
              pc[a].lanlit = UNLIT;
          }
        }
        else if (pc[a].torchlit == LIT)
        {
          if (character[c[a]].inventory[pc[a].rhand] != 50 && character[c[a]].inventory[pc[a].lhand] != 50)
            pc[a].torchlit = UNLIT;
          else
          {
            if ((character[c[a]].torchlight -= 1) <= 0)
            {
              pc[a].torchlit = UNLIT;
              character[c[a]].torchlight = itemlist[50].level;
              if (character[c[a]].inventory[pc[a].rhand] == 50)
              {
                if (removeitem(c[a], pc[a].rhand) == 0)
                  shift(a, pc[a].rhand);
              }
              else if (character[c[a]].inventory[pc[a].lhand] == 50)
              {
                if (removeitem(c[a], pc[a].lhand) == 0)
                  shift(a, pc[a].lhand);
              }
              pc[a].upd = (pc[a].upd | UDHANDS | UDWEIGHT);
            }
          }
        }
        if ((EWC & character[c[a]].cursed) == EWC)
        {
          if (--pc[a].hp <= 0)
          {
            character[c[b]].dead = 0;
            if (--players == 0)
            {
              for (d = 0;d < 4;d++)
              {
                if (c[d] != -1)
                  character[c[d]].playing = 0;
                  _setcursortype(_NORMALCURSOR);
                  return;
              }
            }
          }
          pc[a].hit = 1;
          pc[a].upd |= UDHP;
        }
        if (character[c[a]].inventory[pc[a].ring] == 18)
        {
          if (pc[a].hp < character[c[a]].hpcap)
            pc[a].hp++;
          pc[a].upd |= UDHP;
        }
        else if (character[c[a]].inventory[pc[a].ring] == 34)
        {
          if (pc[a].mp < character[c[a]].mpcap)
            pc[a].mp++;
          pc[a].upd |= UDMP;
        }
        if (pc[a].hp <= character[c[a]].hpcap/10)
        {
          snd.copy(sblank, &sb);
          sb[0] = 2000;
          snd.copy(sb);
        }
      }
      }
      if (!(dx == startx && dy == starty))
      {
        if (map[dx][dy].monsters < 10 && (random(50 - depth) == 0 || depth > 50))
        {
          map[dx][dy].monsters++;
          if (d != -1)
          {
            for (a = 1;a < 5;a++)
            {
              if (doors[dx + doorx[a-1]][dy * 2 + doory[a-1]] % 10 == OPEN && doors[dx + doorx[a-1]][dy * 2 + doory[a-1]] != SOLID)
                break;
            }
            switch (a)
            {
              case MUP: b = 4; e = 0; break;
              case MDOWN: b = 4; e = 9; break;
              case MRIGHT: b = 9; e = 4; break;
              case MLEFT: b = 0; e = 4; break;
              case 5: b = 4; e = 4; break;
            }
            for (a = 0;a < 10;a++)
            {
              if (mon[d][a].hp <= 0)
              {
                mon[d][a].hp = map[dx][dy].monstertype->hpcap;
                mon[d][a].cursed = NONE;
                mon[d][a].x = b;
                mon[d][a].y = e;
                mon[d][a].hit = 0;
                mon[d][a].target = -1;
                snd.copy(sfind);
                break;
              }
            }
            for (a = 0;a < 4;a++)
              if (pc[a].roomx == dx && pc[a].roomy == dy)
                pc[a].upd |= UDMONEY;
          }
        }
      }
    }
    else if (frame == 2)
    {
      for (a = 0;a < 4;a++)
      {
        for (b = 0;b < 10;b++)
        {
        if (mon[a][b].hp > 0)
        {
          if ((EWC & mon[a][b].cursed) == EWC)
          {
            if (--mon[a][b].hp <= 0)
            {
              makegoody(a, mon[a][b].x, mon[a][b].y);
              map[rooms[a][X]][rooms[a][Y]].monsters--;
              map[rooms[a][X]][rooms[a][Y]].goodies++;
            }
            mon[pc[a].rd][b].hit = 2;
          }
        }
        }
      }
    }
    else if (frame == 1)
    {
      for (a = 0;a < 4;a++)
      {
        for (dx = 0;dx < 10;dx++)
        {
          for (dy = 0;dy < 10;dy++)
          {
            switch (random(4))
            {
              case 0: b = 0; d = -1; break;
              case 1: b = 0; d = 1; break;
              case 2: b = -1; d = 0; break;
              case 3: b = 1; d = 0; break;
            }
            if (dx == 0 && b == -1)
              b = 0;
            if (dx == 9 && b == 1)
              b = 0;
            if (dy == 0 && d == -1)
              d = 0;
            if (dy == 9 && d == 1)
              d = 0;
            if (map[rooms[a][X]][rooms[a][Y]].flooded == 1)
            {
              if (floor[a][dx][dy]/10 == TILE/10 && (floor[a][dx+b][dy+d]/10 == CLEARH2O/10 || floor[a][dx+b][dy+d]/10 == MUDDYH2O/10))
                floor[a][dx][dy] = CLEARH2O + random(4);
              if (floor[a][dx][dy]/10 == MUDDYH2O/10 && random(50) == 0)
                floor[a][dx][dy] -= MUDDYH2O-CLEARH2O;
            }
            else
            {
              if ((floor[a][dx][dy]/10 == CLEARH2O/10 || floor[a][dx][dy]/10 == MUDDYH2O/10) && random(3) == 0)
                floor[a][dx][dy] = TILE + random(3)+1;
            }
            if (floor[a][dx][dy]/10 == FIRE/10)
            {
                if ((floor[a][dx+b][dy+d]/10 != CHEST/10 && floor[a][dx+b][dy+d]/10 < TCHEST/10 && floor[a][dx+b][dy+d]/10 < CLEARH2O/10 && random(5) == 0) || floor[a][dx+b][dy+d]/10 == TRAP/10)
                {
                  floor[a][dx+b][dy+d] = FIRE;
                  map[rooms[a][X]][rooms[a][Y]].fire++;
                }
                if (floor[a][dx+b][dy+d]/10 == TRAP/10)
                {
                  floor[a][dx+b][dy+d] = FIRE;
                  map[rooms[a][X]][rooms[a][Y]].fire++;
                }
              if (random(15) == 0)
              {
                floor[a][dx][dy] = TILE + random(3) + 1;
                map[rooms[a][X]][rooms[a][Y]].fire--;
              }
            }
          }
        }
      }
    }
    do {
    a = 0;
    a = getkey();
    for (b = 0;b < 4;b++)
    {
    pkey[b] = NONE;
    if (a == playkeys[b].up)
      pkey[b] = MUP;
    if (a == playkeys[b].down)
      pkey[b] = MDOWN;
    if (a == playkeys[b].right)
      pkey[b] = MRIGHT;
    if (a == playkeys[b].left)
      pkey[b] = MLEFT;
    if (a == playkeys[b].rhand)
      pkey[b] = RHAND;
    if (a == playkeys[b].lhand)
      pkey[b] = LHAND;
    if (a == playkeys[b].menu)
      pkey[b] = MENU;
    if (a == playkeys[b].drop)
      pkey[b] = DROP;
    }
    if (a == ESCAPE)
    {
                   snd.pstop(1);
                   textattr(LIGHTGRAY + (BLACK << 4));
                   window(1, 1, 80, 25);
                   pausescr(soundstat);
                   cx = 1;
                   ox = 0;
                   a = 0;
                   do {
                     for (b = 0;b < 4;b++)
                     {
                       gotoxy(30, 5+b);
                       if (c[b] == -1)
                         cprintf("Character: X");
                       else
                         cprintf("Character: %d", c[b]);
                     }
                     if (cx < 1)
                       cx = 8;
                     else if (cx > 8)
                       cx = 1;
                     if (cx != ox)
                     {
                       gotoxy(28, ox);
                       putch(32);
                       gotoxy(28, cx);
                       putch('>');
                       ox = cx;
                     }
                     switch(getkey())
                     {
                       case UP: cx--; break;
                       case DOWN: cx++; break;
                       case SPACE: switch (cx)
                                   {
                                     case 1: a = 1; break;
                                     case 2: b = 0;
                                             for (d = 0;d < 4;d++)
                                               if (c[d] != -1)
                                                 b = 1;
                                             if (b == 1)
                                             {
                                               gotoxy(1, 20);
                                               cputs("All characters have not left.\r\n");
                                               cputs("(r)eturn to game, (k)ill characters, or (s)ave game?\r\n");
                                               b = 0;
                                               do {
                                                 switch (getch())
                                                 {
                                                   case 'r': b = 1; break;
                                                   case 'k': a = 1;
                                                             b = 1;
                                                             for (d = 0;d < 4;d++)
                                                               if (c[d] != -1 && character[c[d]].playing == 1)
                                                                 character[c[d]].dead = 0;
                                                             depth = 0;
                                                             break;
                                                   case 's': if (quicksave() != 0)
                                                               cputs("Sorry save error. Press any key to return to main menu");
                                                             else
                                                             {
                                                               cputs("Game saved.  Press any key to exit program");
                                                               quicksaved = 1;
                                                             }
                                                             getch();
                                                             _setcursortype(_NORMALCURSOR);
                                                             return;
                                                 }
                                               } while (b == 0);
                                             }
                                             else
                                               depth = 0;
                                             break;
                                     case 3: b = 0;
                                             do {
                                               switch (getkey())
                                               {
                                                 case LEFT: if (--gamespeed < 0)
                                                              gamespeed = 0;
                                                              break;
                                                 case RIGHT: if (++gamespeed > 30000)
                                                             gamespeed = 30000;
                                                             break;
                                                 case SPACE: b = 1; break;
                                               }
                                               gotoxy(38, 3);
                                               cprintf("%d ", gamespeed);
                                             } while (b == 0);
                                             break;
                                     case 4: (soundstat == 1) ? (soundstat = 0) : (soundstat = 1);
                                             gotoxy(37, 4);
                                             cputs(on_off[soundstat]);
                                             snd.sndon_off(soundstat);
                                             break;
                                     case 5: gotoxy(28, cx);
                                             putch(SPACE);
                                             chmenu(0, soundstat);
                                             ox = 0;
                                             break;
                                     case 6: gotoxy(28, cx);
                                             putch(SPACE);
                                             chmenu(1, soundstat);
                                             ox = 0;
                                             break;
                                     case 7: gotoxy(28, cx);
                                             putch(SPACE);
                                             chmenu(2, soundstat);
                                             ox = 0;
                                             break;
                                     case 8: gotoxy(28, cx);
                                             putch(SPACE);
                                             chmenu(3, soundstat);
                                             ox = 0;
                                             break;
                                   }
                                   break;
                     }
                   } while (a == 0);
                   clrscr();
                   namebar();
                   for (b = 0;b < 4;b++)
                   {
                     if (pc[b].control >= PLAYER1 && pc[b].control <= PLAYER4)
                     {
                       for (a = 0;a < 4;a++)
                         if (pc[a].control == pc[b].control && a != b)
                           pc[a].control = STAND;
                       pc[b].inmenu = -1;
                     }
                   }
                   for (b = 0;b < 4;b++)
                   {
                     if (pc[b].view != NONE)
                     {
                       for (a = 0;a < 4;a++)
                       {
                         if (pc[a].view == pc[b].view && a != b)
                           pc[b].view = NONE;
                       }
                       pc[b].inmenu = -1;
                     }
                   }
    }
    for (b = 0;b < 4;b++)
    {
      if (pkey[b] != 0)
        stickkey(&kbuf[b], pkey[b]);
    }
    } while (a != 0);
    for (a = 0;a < 4;a++)
    {
    if (c[a] != -1 && character[c[a]].playing == 1 && character[c[a]].dead == 1)
    {
      if ((FLC & character[c[a]].cursed) == FLC)
      {
        dx = 0;
        dy = 0;
        switch (random(4)+1)
        {
          case MUP: dy = -1; break;
          case MDOWN: dy = 1; break;
          case MRIGHT: dx = 1; break;
          case MLEFT: dx = -1; break;
        }
        if (pc[a].fx + dx < 0 || pc[a].fx + dx > 9 || pc[a].fy + dy < 0 || pc[a].fy + dy > 9)
        {
          dx = 0;
          dy = 0;
        }
        pc[a].fx += dx;
        pc[a].fy += dy;
        if (pc[a].fx == 4 && pc[a].fy == 4 && map[pc[a].roomx][pc[a].roomy].torch == UNLIT)
          map[pc[a].roomx][pc[a].roomy].torch = LIT;
      }
      if (pc[a].inaction == 0)
      {
        switch (pc[a].control)
        {
          case PLAYER1: humancon(pullkey(&kbuf[0]), a); break;
          case PLAYER2: humancon(pullkey(&kbuf[1]), a); break;
          case PLAYER3: humancon(pullkey(&kbuf[2]), a); break;
          case PLAYER4: humancon(pullkey(&kbuf[3]), a); break;
          case STAND: if (random(3) != 0)
                        humancon(attacknear(a), a);
                      break;
          case TASK: if (random(3) != 0)
                       humancon(task(a), a);
                     break;
          case FOLLOW1:
          case FOLLOW2:
          case FOLLOW3:
          case FOLLOW4: if (random(3) != 0)
                          humancon(follow(a), a);
                        break;
        }
      }
      if (pc[a].inaction != 0)
      {
        switch (pc[a].facing)
        {
          case MUP: dy = -1; break;
          case MDOWN: dy = 1; break;
          case MRIGHT: dx = 1; break;
          case MLEFT: dx = -1; break;
        }
        if (pc[a].inaction < 10)
        {
          findfree(&projec, 1);
          if (pc[a].moving < MRIGHT)
            d = 179;
          else
            d = 196;
          sc(projec[0], pc[a].x, pc[a].y, pc[a].facing, character[c[a]].magic * 300, 12, 0, a+10, pc[a].rd, YELLOW, d, 92, d, 47);
        }
        if (--pc[a].inaction == 10)
          pc[a].inaction = 0;
      }
    }
    }
    for (a = 0;a < 4;a++)
    {
    if (rdu[a] > 0)
    {
      for (b = 0;b < 4;b++)
        if (pc[b].rd == a && c[b] != -1)
          mt = map[pc[b].roomx][pc[b].roomy].monstertype;
      for (b = 0;b < 10;b++)
      {
        dx = 0;
        dy = 0;
        if (mon[a][b].hp < 0)
          mon[a][b].hp = 0;
        if (mon[a][b].hp > 0)
        {
          if (mon[a][b].target == -1)
          {
            d = random(rdu[a])+1;
            for (e = 0;e < 4;e++)
            {
              if (pc[e].rd == a && c[e] != -1)
              {
                if (--d == 0)
                  break;
              }
            }
            mon[a][b].target = e;
          }
          e = NONE;
          d = mon[a][b].target;
          if (((mon[a][b].x-1 == pc[d].x && mt->brains != 3 && mt->brains != 4) || (mon[a][b].x > pc[d].x && (mt->brains == 3 || mt->brains == 4))) && mon[a][b].y == pc[d].y)
            e = MLEFT;
          if (((mon[a][b].x+1 == pc[d].x && mt->brains != 3 && mt->brains != 4) || (mon[a][b].x < pc[d].x && (mt->brains == 3 || mt->brains == 4))) && mon[a][b].y == pc[d].y)
            e = MRIGHT;
          if (mon[a][b].x == pc[d].x && ((mon[a][b].y > pc[d].y && (mt->brains == 3 || mt->brains == 4)) || (mon[a][b].y-1 == pc[d].y && mt->brains != 3 && mt->brains != 4)))
            e = MUP;
          if (mon[a][b].x == pc[d].x && ((mon[a][b].y < pc[d].y && (mt->brains == 3 || mt->brains == 4)) || (mon[a][b].y+1 == pc[d].y && mt->brains != 3 && mt->brains != 4)))
            e = MDOWN;
          if (mt->brains == 5)
          {
            if (random(500) == 0)
            {
              e = -1;
              mon[a][b].cursed = NONE;
              snd.copy(scure);
            }
            if (e != NONE && character[c[mon[a][b].target]].inventory[pc[mon[a][b].target].ring] != 51)
            {
              switch (random(1000))
              {
                case EWC: character[c[mon[a][b].target]].cursed |= EWC; e = -1; break;
                case WOWC: character[c[mon[a][b].target]].cursed |= WOWC; e = -1; pc[mon[a][b].target].upd |= UDWEIGHT; break;
                case ASFC: character[c[mon[a][b].target]].cursed |= ASFC; e = -1; break;
                case FATC: character[c[mon[a][b].target]].cursed |= FATC; e = -1; break;
                case IFC: character[c[mon[a][b].target]].cursed |= IFC; e = -1; break;
              }
              if (e == -1)
              {
                pc[mon[a][b].target].upd |= UDCURSE;
                snd.copy(scurse);
              }
            }
          }
          if (e == NONE)
          {
            if (mt->brains == 0 || mt->brains == 3)
            {
              g = random(4)+1;
              switch (g)
              {
                case MUP: dy = -1; break;
                case MDOWN: dy = 1; break;
                case MRIGHT: dx = 1; break;
                case MLEFT: dx = -1; break;
              }
              if (random (2) == 0)
              {
                e = g;
                dx = 0;
                dy = 0;
              }
            }
            if (mt->brains == 1 || mt->brains == 2 || mt->brains == 4 || mt->brains == 5)
            {
              d = random(2);
              if (d == 0)
              {
                if (pc[mon[a][b].target].x - mon[a][b].x < 0)
                  dx = -1;
                else if (pc[mon[a][b].target].x - mon[a][b].x > 0)
                  dx = 1;
              }
              else
              {
                if (pc[mon[a][b].target].y - mon[a][b].y < 0)
                  dy = -1;
                else if (pc[mon[a][b].target].y - mon[a][b].y > 0)
                  dy = 1;
              }
              d = floor[a][mon[a][b].x + dx][mon[a][b].y + dy] / 10;
              if ((mt->brains == 2 || mt-> brains == 5) && (d == TRAP / 10 || d == CHEST/10 || d == TCHEST/10 || d == CRUMBWALL/10 || d == SOLIDWALL/10 || (mon[a][b].x + dx == 4 && mon[a][b].y + dy == 4 && map[rooms[a][X]][rooms[a][Y]].torch != NOTORCH)))
              {
                dx *= -1;
                dy *= -1;
                if (dx == 0)
                {
                  d = floor[a][mon[a][b].x + 1][mon[a][b].y] / 10;
                  if (d != TRAP / 10 && d != CHEST / 10 && d != TCHEST / 10 && mon[a][b].x != 9 && !(mon[a][b].x + 1 == 4 && mon[a][b].y == 4 && map[rooms[a][X]][rooms[a][Y]].torch != NOTORCH))
                  {
                    dx = 1;
                    dy = 0;
                  }
                  d = floor[a][mon[a][b].x - 1][mon[a][b].y] / 10;
                  if (d != TRAP / 10 && d != CHEST / 10 && d != TCHEST / 10 && mon[a][b].x != 0 && !(mon[a][b].x - 1 == 4 && mon[a][b].y == 4 && map[rooms[a][X]][rooms[a][Y]].torch != NOTORCH))
                  {
                    dx = -1;
                    dy = 0;
                  }
                }
                else
                {
                  d = floor[a][mon[a][b].x][mon[a][b].y + 1] / 10;
                  if (d != TRAP / 10 && d != CHEST / 10 && d != TCHEST / 10 && mon[a][b].y != 9 && !(mon[a][b].x == 4 && mon[a][b].y + 1 == 4 && map[rooms[a][X]][rooms[a][Y]].torch != NOTORCH))
                  {
                    dx = 0;
                    dy = 1;
                  }
                  d = floor[a][mon[a][b].x][mon[a][b].y - 1] / 10;
                  if (d != TRAP / 10 && d != CHEST / 10 && d != TCHEST / 10 && mon[a][b].y != 0 && !(mon[a][b].x == 4 && mon[a][b].y - 1 == 4 && map[rooms[a][X]][rooms[a][Y]].torch != NOTORCH))
                  {
                    dx = 0;
                    dy = -1;
                  }
                }
              }
            }
          }
          if ((mt->brains == 2 || mt->brains == 5) && mon[a][b].hit == 1)
          {
            dx *= -1;
            dy *= -1;
            if (dx == 0 || e == MUP || e == MDOWN)
            {
              d = floor[a][mon[a][b].x + 1][mon[a][b].y] / 10;
              if (d != TRAP / 10 && d != CHEST / 10 && d != TCHEST / 10)
              {
                dx = 1;
                dy = 0;
              }
              d = floor[a][mon[a][b].x - 1][mon[a][b].y] / 10;
              if (d != TRAP / 10 && d != CHEST / 10 && d != TCHEST / 10)
              {
                dx = -1;
                dy = 0;
              }
            }
            else if (dy == 0 || e == MRIGHT || e == MLEFT)
            {
              d = floor[a][mon[a][b].x][mon[a][b].y + 1] / 10;
              if (d != TRAP / 10 && d != CHEST / 10 && d != TCHEST / 10)
              {
                dx = 0;
                dy = 1;
              }
              d = floor[a][mon[a][b].x][mon[a][b].y - 1] / 10;
              if (d != TRAP / 10 && d != CHEST / 10 && d != TCHEST / 10)
              {
                dx = 0;
                dy = -1;
              }
            }
            e = NONE;
          }
            if ((IFC & mon[a][b].cursed) == IFC)
            {
              g = 0;
              for (d = 0;d < 4;d++)
              {
                if (doors[rooms[a][X] + doorx[d]][rooms[a][Y] * 2 + doory[d]] % 10 == OPEN && doors[rooms[a][X] + doorx[d]][rooms[a][Y] * 2 + doory[d]] != SOLID)
                  g = d;
              }
              if (g == 0)
              {
                dx *= -1;
                dy *= -1;
              }
              else
              {
                switch (g)
                {
                  case MUP-1: dx = 4;
                            dy = 0;
                            break;
                  case MDOWN-1: dx = 4;
                              dy = 9;
                              break;
                  case MRIGHT-1: dx = 9;
                               dy = 4;
                               break;
                  case MLEFT-1: dx = 0;
                              dy = 4;
                              break;
                }
                if (mon[a][b].x == dx && mon[a][b].y == dy)
                {
                  mon[a][b].hp = 0;
                  map[rooms[a][X]][rooms[a][Y]].monsters--;
                }
                else if (dx - mon[a][b].x < 0)
                {
                  dx = -1;
                  dy = 0;
                }
                else if (dx - mon[a][b].x > 0)
                {
                  dx = 1;
                  dy = 0;
                }
                else if (dy - mon[a][b].y < 0)
                {
                  dx = 0;
                  dy = -1;
                }
                else if (dy - mon[a][b].y > 0)
                {
                  dx = 0;
                  dy = 1;
                }
              }
            }
          if (mon[a][b].x + dx < 0 || mon[a][b].x + dx > 9 || mon[a][b].y + dy < 0 || mon[a][b].y + dy > 9)
          {
            dx = 0;
            dy = 0;
          }
          for (d = 0;d < 4;d++)
          {
            if (mon[a][b].x + dx == pc[d].x && mon[a][b].y + dy == pc[d].y && character[c[d]].playing == 1)
            {
              dx = 0;
              dy = 0;
            }
          }
          for (d = 0;d < 10;d++)
          {
            if (d != b && mon[a][b].x + dx == mon[a][d].x && mon[a][b].y + dy == mon[a][d].y && mon[a][d].hp > 0)
            {
              dx = 0;
              dy = 0;
            }
          }
          if ((random(30)+1 > mt->speed && (WOWC & mon[a][b].cursed) != WOWC) || (random(100) == 0 && (WOWC & mon[a][b].cursed) == WOWC) || ((IFC & mon[a][b].cursed) == IFC && (WOWC & mon[a][b].cursed) != WOWC));
          else
          {
            dx = 0;
            dy = 0;
            e = NONE;
          }
          d = floor[a][mon[a][b].x + dx][mon[a][b].y + dy] / 10;
          if (d == CHEST/10 || d == TCHEST/10 || d == SOLIDWALL/10 || d == CRUMBWALL/10 || (map[rooms[a][X]][rooms[a][Y]].torch != NOTORCH && mon[a][b].x + dx == 4 && mon[a][b].y + dy == 4))
          {
            dx = 0;
            dy = 0;
          }
            if (d == TRAP/10 || d == FIRE/10)
            {
              mon[a][b].hit = 2;
              if (d == TRAP/10)
              {
                if ((mon[a][b].hp -= depth*5) <= 0)
                  mon[a][b].hp = 0;
              }
              else
              {
                if ((mon[a][b].hp -= depth) <= 0)
                  mon[a][b].hp = 0;
              }
              map[pc[mon[a][b].target].roomx][pc[mon[a][b].target].roomy].traps--;
              if (d == TRAP/10)
              {
                floor[a][mon[a][b].x+dx][mon[a][b].y+dy] -= TRAP;
                if (floor[a][mon[a][b].x+dx][mon[a][b].y+d